︠af47d415-b750-404e-9192-4b74c5bca668s︠



︡33a68583-9b8b-44f7-ad0c-4e891627ee8e︡{"done":true}︡
︠fe7da35d-8932-454f-9440-c3bcea52dc5ds︠
                                #              FUNCIONES BASICAS

# Calcula la distancia euclidea entre dos puntos
def dist(A,B):
    return sqrt((A[0]-B[0])**2+(A[1]-B[1])**2)

# Evitamos tener que hacer la raiz cuadrada cuando tenemos que comparar distancias
def dist2(A,B):
     return (A[0]-B[0])**2+(A[1]-B[1])**2
# Nos calcula el area signada de los punto A, B y C con esa orientación. Siendo positiva si la orientación sigue el sentido antihorario , negativa en caso contrario y cero si los puntos están alineados.
def sarea(A,B,C):
    return (1/2)*((B[0]-A[0])*(C[1]-A[1])-(C[0]-A[0])*(B[1]-A[1]))
# Nos da el signo del area signada. Siendo -1 si va en sentido horario, 1 en sentido antihorario y 0 si están alineados.
def orientation(A,B,C):
    return sign((1/2)*((B[0]-A[0])*(C[1]-A[1])-(C[0]-A[0])*(B[1]-A[1])))
# Calcula el punto medio de A y B.
def midPoint(A,B):
    return [((A[0]+B[0])/2),((A[1]+B[1])/2)]

#Primero comprobamos que la coordenada x de P esté entre las coordenadas x de los puntos que definen el segmento. 
#Después repetimos el mismo proceso para las coordenadas y.
#Por último comprobamos si están alineados calculando la orientación.
#Devolviendo True si el punto está en el segmento y False si no lo está.

def inSegment(P,s):
        if ((s[0][0]<=P[0]<=s[1][0] or s[1][0]<=P[0]<=s[0][0]) & (s[1][1]<=P[1]<=s[0][1] or s[0][1]<=P[1]<=s[1][1])):
            if orientation(P,s[0],s[1])==0:
                return True
            else:
                return False
        else:
            return False


#Calculamos las orientaciones del conjutno formado por  P y cada par distinto de vértices y si dan a la vez 1 y -1 quiere decir
#que el punto no pertenece al triángulo. Devuelve True si pertenece al triángulo y False en caso contrario.
def inTriangle(P,t):
    L=(orientation(t[0],t[1],P),orientation(t[0],P,t[2]),orientation(P,t[1],t[2]))
    if (1 in L and -1 in L): return False
    return True
# Si se intersecan hay dos casos:
# -Se cortan en un punto que no es extremo de ningún segmento. Para ello hacemos la orientación de los extremos de un            segmento con cada uno de los extremos del otro.Si son distintas, hacemos el mismo paso pero invirtiendo los papeles. Si      vuelven a ser disntintas, quiere decir que se cortan en un punto.
# -Uno de los extremos de un segmento está contenido en el otro. Para ello usamos la función inSegment y vemos si se cortan o    no.

def segmentIntersectionTest(a,b):
    if (orientation(a[0],a[1],b[0])!=orientation(a[0],a[1],b[1])) & (orientation(b[0],b[1],a[0])!=orientation(b[0],b[1],a[1])):
        return True
    else:
        return inSegment(a[0],b) or inSegment(a[1],b) or inSegment(b[0],a) or inSegment(b[1],a)

# Sacamos los vectores de cada recta. Comprobamos si el determinante de esos dos vectores es cero, sino lo es se cortan en un punto. Hallamos el punto resolviendo el sistema Ax=b.
def lineIntersection(r,s):
    A=vector(r[0])
    B=vector(r[1])
    C=vector(s[0])
    D=vector(s[1])
    AB=B-A
    CD=D-C
    if(det(matrix([AB,CD]))==0):
        print("no se cortan en un punto")
        return
    else:
        AA=matrix([[A[1]-B[1],B[0]-A[0]],[C[1]-D[1],D[0]-C[0]]])
        bb=vector([A[1]*B[0]-A[0]*B[1],C[1]*D[0]-C[0]*D[1]])
        return list(AA\bb)

# Calcula el volumen signado de 4 punto en tres dimensiones. Siendo positivo si la orientación es en sentido antihorario, negativa en sentido horario y cero si están alienados.
def svolume(a,b,c,d):
    Ap = [a[0],a[1],a[0]**2+a[1]**2,1]
    Bp = [b[0],b[1],b[0]**2+b[1]**2,1]
    Cp = [c[0],c[1],c[0]**2+c[1]**2,1]
    Dp = [d[0],d[1],d[0]**2+d[1]**2,1]
    M =matrix([Ap,Bp,Cp,Dp])
    return M.det()
#incircle test. Entrada cuatro puntos a,b,c,d y salida 1, -1 o 0 dependiendo de que el punto d sea interior, exterior o este en la frontera del circulo que determinan a,b y c.


def inCircle(a,b,c,d):
    if (sarea(a,b,c) == 0):
        print ("error")
        return
    elif ((sarea(a,b,c)*svolume(a,b,c,d))>0):

        return int(1)
    elif ((sarea(a,b,c)*svolume(a,b,c,d))==0):

        return int(0)
    else:
        return int(-1)

#Devulve el circuncentro de tres puntos.Primero comprobamos que no estén alineados y luego utilizamos la fórmula del circuncentro.
def circumcenter(a,b,c):
    sa=sarea(a,b,c)
    if (sa==0):
        print ("alineados")
        return
    cx=matrix([[1,1,1],[a[1],b[1],c[1]],[a[0]**2+a[1]**2,b[0]**2+b[1]**2,c[0]**2+c[1]**2]]).det()/(-4*sa)
    cy=matrix([[1,1,1],[a[0],b[0],c[0]],[a[0]**2+a[1]**2,b[0]**2+b[1]**2,c[0]**2+c[1]**2]]).det()/(4*sa)
    return [cx,cy]
#                                                ORDENACION GEOMETRICA
#1.- Ordenar una lista de números de menor a mayor.

# Ordena una lista de número de menor a mayor. Empleando la estrategia de divide y vencerás.
def mergeSort(alist):
    
    if len(alist)>1:
        mid = len(alist)//2
        lefthalf = alist[:mid]
        righthalf = alist[mid:]

        mergeSort(lefthalf)
        mergeSort(righthalf)

        i=0
        j=0
        k=0
        while i < len(lefthalf) and j < len(righthalf):
            if lefthalf[i] < righthalf[j]:
                alist[k]=lefthalf[i]
                i=i+1
            else:
                alist[k]=righthalf[j]
                j=j+1
            k=k+1

        while i < len(lefthalf):
            alist[k]=lefthalf[i]
            i=i+1
            k=k+1

        while j < len(righthalf):
            alist[k]=righthalf[j]
            j=j+1
            k=k+1
    return alist
#2.- Ordenar una lista de números de menor a mayor, sabiendo que se encuentra ordenada de mayor a
#menor.
# Como sabemos que está ordenada de mayor a menor, solo hay que darle la vuelta con reverse.
def ejercicio2(L):
    L.reverse()
    return L
#Concatenamos las dos listas y le aplicamos el metodo mergeSort
def ejercicio3(L1,L2):
    L1.extend(L2)
    mergeSort(L1)
    return L1

# Tan solo hay que hacer un sorted de la lista
def ejercicio4(p):
    return sorted(p)
def sortv(p,v):
    
    return

def angularSort(p,c):
    def compare(p,q):
        if p==q:
            return int(0)
        if p[1]>c[1]>=q[1]:
            return int(1)
        elif q[1]>c[1]>=p[1]:
            return int(-1)
        elif orientation(c,p,q)==1:
            return int(1)
        elif orientation(c,p,q)==-1:
            return int(-1)
        elif dist2(c,p)<dist2(c,q):
            return int(1)
        else:
            return int(-1)
    
    q=deepcopy(p)
    q=sorted(q,cmp=compare)  
    q.reverse()
    return q

 
# para visualizar
#   una lista de puntos p:   point(p)
#   una poligonal definida por una lista de puntos p:  line(p)
# se pueden añadir parametros (color, tamaño del punto, grosor de la linea, aspecto,...
point([[random(),random()] for i in range(100)],aspect_ratio=1,color="red",size=100,faceted=100)
 
line([[random(),random()] for i in range(100)],aspect_ratio=1,color="red",thickness=2)
 



# poligonizacion X-monotona
#cogemos los puntos máximo y mínimo de la lista de puntos y a partir de ellos 
#dividimos los puntos en dos listas según el área signada respecto de estos dos puntos.
#Ordenamos ambas listas y unimos.
def polygonization(p):
    U=[]
    L=[]
    #Buscamos el valor max y min de p
    maxim=max(p)
    minim=min(p)
    for i in range(len(p)):
        if sarea(maxim,p[i],minim)>=0: U.append(p[i])
        else: L.append(p[i])
    U= sorted(U)
    L= sorted(L)
    U.reverse()
    return L+U       
    
# poligonizacion estrellada
# cogemos el punto medio de la lista de puntos y aplicamos angularsort

def starPolygonization(p):
    C=midPoint(p[0],p[1])
    return angularSort(p,C)


#Le pasamos un poligono y una recta sobre la que se hará el corte. El resultado es el polígono formado por el corte de la recta sobre el anterior polígono.
# Primero hallamos el area signada para todos los puntos.
# -Si el area signada con la recta es mayor o igual que cero, añadimos el punto. Ahora nos fijamos en el siguiente punto, si    el area signada con la recta es negativo, quiere decir que la recta que une el punto anterior con el actual, corta a la      recta. Calculamos el punto de intersección y le añadimos a la lista de puntos.
# -Sino era mayor, quiere decir que está por debajo. Hallamos el sarea del siguiente y si es positivio, añadimos el punto de interseccion de la recta definida por los puntos y la recta de corte inicial.
def clipping(P,r):
    n=len(P)
    L=[]
    for i in range(n):
        if sarea(r[0],r[1],P[i])>=0:
            L.append(P[i])
            if sarea(r[0],r[1],P[(i+1)%n])<0:
                M=lineIntersection(r,[P[(i+1)%n],P[i]])
                L.append(M)
        elif sarea(r[0],r[1],P[(i+1)%n])>=0:
            N=lineIntersection(r,[P[(i+1)%n],P[i]])
            L.append(N)
    return L

### funcion auxiliar que detecta si un vértice es oreja en tiempo O(n)
# Primero escogemos un punto.
# Después calculamos el area signada del anterior a ese punto, el punto y el siguiente. Si es negativa o iguala cero, no es     oreja.
# Si lo anterior no era cierto, aún queda por comprobar que ningún vértice del polígono esté dentro del triángulo que forman.   Si ninguno de los puntos estaba dentro, es un vértice oreja.
def earTest(P,i):
    n=len(P)
    if sarea(P[i-1],P[i],P[(i+1)%n])<=0:return False
    j=0
    while j<n:
            if j in [(i-1)%n,i,(i+1)%n]:j+=1
            else:
                if inTriangle(P[j],[P[i-1],P[i],P[(i+1)%n]]):return False
                else:
                    j+=1
    return True
# devolver el indice del vertice oreja
# Aplicamos el test anterior a todos los puntos del polígono y si alguno es oreja, imprimimos el indice de la primera oreja     encontrada.
def ear(P):
    n=len(P)
    a=0
    m=0
    while(a<n)and(m==0):
        if (earTest(P,a))==True: m=1
        else:a=a+1
        
    return a
            
 
# Hacemos una copia del poligono
# Buscamos una oreja y metemos en la lista un vector con los vertices de la oreja. A continuación eliminamos el vértice oreja   y repetimos este paso hasta que solo queden 3 vertices(vertices necesarios para formar un triángulo) y los añadimos           también.
def otectomyTriangulation(P):
    p=deepcopy(P)
    T=[]
    n=len(p)
    while n>3:
        e=ear(p)
        T.append([p[e-1],p[e],p[(e+1)%n]])
        del p[e]
        n -= 1 
    T.append(p)
    return T

# solucion 1: con la funcion ear(P)

def diagonal_1(P):
    n=len(P)
    a=ear(P)
    
    return [P[a-1],P[(a+1)%n]]
#Fuerza bruta búsqueda de vértices
# Tenemos que hallar los puntos interiores. Para ello hacemos todas las combinaciones posibles de 3 puntos y vamos probando con los restantes si son interiores al triangulo que forman. Así conseguimos una lista con puntos interiores y los restantes seran los puntos de la envolvente. Elegimos la ordenacion angular para hacer al envolvente.
def convexHullBF1(p):
    n=len(p)
    interiores=[]
    for i in Combinations(n,3):
        for j in range(n):
            if j <> i[0] and j <> i[1] and j <> i[2] and inTriangle(p[j],[p[i[0]],p[i[1]],p[i[2]]]):
                if j not in interiores:
                    interiores.append(j)
    C=[]               
    for i in range(n):
        if i not in interiores:
            C.append(i)
    CH=[p[i] for i in C]
    M=midPoint(CH[0],CH[1])
    CH=angularSort(CH,M)
    return CH
#Fuerza bruta búsqueda de aristas
# Hacemos un bucle con todas las combinaciones de aristas del poligono posibles. Luego cogemos otro punto y hallamos la orientación. Si es distinta de cero, comprobamos si ya teniamos esa orientación, 
def convexHullBF2(P):
    n=len(P)
    E=[]
    for i in Combinations(n,2):
        L=[]
        j=0
        while j < n:
            A = orientation(P[i[0]], P[i[1]], P[j])
            if A == 0:
                j += 1
                continue
            else:
                if A not in L:
                    L.append(A)
                if len(L) > 1:
                    L=[]
                    j += 1
                    break
            j += 1
        if len(L) == 1:
            E.append(i)
    C=[]
    for i in E:
        C.append(i[0])
        C.append(i[1])
    C = sorted(C)
    CC = [C[0]]
    for i in range(1, len(C)):
        if C[i] <> C[i-1]:
            CC.append(C[i])
    CH = starPolygonization([P[i] for i in CC])
    return CH
 
#Algoritmo de Graham
#Este algoritmo utiliza una lista en la que va almacenando y ordenando correctamente los puntos que constituyen los extremos del cierre convexo.
#Primero elegimos un primer punto para almacenar en la lista. A continuación vamos almacenando el resto en la lista, ordenados según el valor del ángulo que forman con el primer punto que escogimos.
#Después recorremos la lista que hemos formado, tomando en cada momento tres puntos: Inicial, Medio y Final.
#Comprobamos la orientación que forman Inicial, Medio y Final (IMF).
#Si es positiva, Medio pasará a ser Inicial, Final pasará a ser Medio y el siguiente elemento de la lista pasará a ser Final.
#Si es negativa, Medio será borrado de la lista, Inicial pasará a ser Medio, el anterior elemento de la lista pasará a ser Inicial, y Final queda inalterado.
def convexHullGraham(p):
    P=deepcopy(p)
    from operator import itemgetter
    M = min(P, key=itemgetter(1))
    P = angularSort(P, M)
    i = 1 
    while P[i] <> M:
        if orientation(P[i-1], P[i], P[i+1])<0:
            del P[i]
            i -= 1
        else:
            i += 1
    return P
#Quickhull 
#Tomamos los puntos más a la izquierda y el más a la derecha (ambos podemos
#confirmar que forman parte de la envolvente). Con recursividad y a partir de estos dos, cogiendo
#puntos de P por encima y por debajo encontramos el cierre convexo.

def dome(p,A,B):
    def comp(a):
        return sarea(B,A,a)
    if len(p)==0:
        return [B]
    M=max(p,key=comp)
    
    L1,L2=[],[]
    for i in p:
        if sarea(A,i,M)>0:
            L1.append(i)
        if sarea(M,i,B)>0:
            L2.append(i)
            
    return dome(L1, A, M) + dome(L2,M,B)+[B]
    
def quickhull(p):
    A,B=max(p), min(p)
    return dome(p,A,B)+dome(p,B,A)

#segunda parte
# funcion que crea un DCEL, para un poligono
def dcel(P):
    n=len(P)
    V=[[P[i],i] for i in range(len(P))]
    e=[[i,n+i,(i-1)%n,(i+1)%n,1]for i in range(n)]+[[(i+1)%n,i,n+(i+1)%n,n+(i-1)%n,0]for i in range(n)]
    f=[n,0]
    return [V,e,f]

# funciones para referirse a los elementos asociados a un elemento del DCEL

# indice del origen de una arista e
def origin(e,D):
    return D[1][e][0]

# coordenadas del origen de la arista e
def originCoords(e,D):
    return D[0][origin(e,D)][0]

# arista gemela de la arista e    
def twin(e,D):
    return D[1][e][1]

# arista previa de la arista e    
def prev(e,D):
    return D[1][e][2]

# arista siguiente de la arista e    
def next(e,D):
    return D[1][e][3] 

# indice de la cara de cuyo borde forma parte la arista e    
def face(e,D):
    return D[1][e][4]               

# indice de una de las aristas del borde de la cara c
def edge(c,D):
    return D[2][c]
        
# funcion para dibujar las aristas de un DCEL

def plotDCEL(D):
    return sum(line([originCoords(i,D),originCoords(twin(i,D),D)],aspect_ratio=1) for i in range(len(D[1])))  
    
# funcion para colorear una cara de un DCEL

def plotFace(c,D,col):

    f=D[2][c]
    C=[f]
    f=next(f,D)
    while f <> C[0]:
        C.append(f)
        f=next(f,D)
    
    P=[originCoords(j,D) for j in C]
    return polygon(P,color=col, alpha=.5)     

# funcion para colorear las caras de un DCEL
    
def colorDCEL(D):
    return sum(plotFace(i,D,(random(),random(),random())) for i in range(1,len(D[2])))
# funcion para dividir una cara del DCEL D por una diagonal
# e1 y e2 son las aristas cuyos orígenes son los extremos de la diagonal que divide la cara

def splitFace(e1,e2,D):
    
    # si no son aristas de la misma cara o si son adyacentes sus origenes no definen una diagonal
    if face(e1,D) <> face(e2,D) or origin(e2,D) == origin(twin(e1,D),D) or origin(e1,D) == origin(twin(e2,D),D):
        print "no diagonal"
        return
    
    nv, ne, nf = len(D[0]), len(D[1]), len(D[2])
    preve1 = prev(e1,D)
    preve2 = prev(e2,D)
    k=face(e1,D)
    
    # añadimos las aristas nuevas
    D[1].append([origin(e1,D),ne+1,preve1,e2,k])
    D[1].append([origin(e2,D),ne,preve2,e1,nf])
    
    # modificamos aristas afectadas
    D[1][preve1][3]=ne
    D[1][e1][2]=ne+1
    D[1][preve2][3]=ne+1
    D[1][e2][2]=ne
    i=e1
    while i<>ne+1:
        D[1][i][4]=nf
        i=next(i,D)
    
    #modificamos la cara afectada
    D[2][k]=ne
    
    # añadimos la nueva cara
    D[2].append(ne+1)
def faceEdges(c,D):
    e=edge(c,D)
    C=[e]
    e=next(e,D)
    while e <> C[0]:
        C.append(e)
        e=next(e,D)
    return C

def faceVertices(c,D):
    A = faceEdges(c,D)
    V = [D[1][A[i]][0] for i in range(len(A))]
    return V

def faceVerticesCoords(c,D):
    A = faceEdges(c,D)
    coords = [originCoords(A[i],D) for i in range(len(A))]
    return A

def faceNeighbours(c,D):
    A = faceEdges(c,D)
    coords = [twin(A[i],D) for i in range(len(A))]
    return A

def vertexEdges(v,D):
    e0=D[0][v][1]
    E=[e0]
    e=twin(prev(e0,D),D)
    while e<>e0:
        E.append(e)
        e=twin(prev(e,D),D)
    return E

def vertexFan(v,D):
    A=vertexEdges(v,D)
    C=[face(A[i],D) for i in range(len(A))]
    return C

# CONVEX HULL
# esta funcion no sirve en general
# pero si para casos en que la cara externa es un poligono estrellado o monotono
def DCELconvexHull(D): #scan de Graham
    E=faceEdges(0,D)
    V=[[originCoords(i,D),i] for i in E]
    m=min(V)[1]
    e=next(m,D)
    while origin(e,D)<>origin(m,D):
        if sarea(originCoords(prev(e,D),D),originCoords(e,D),originCoords(next(e,D),D))>0:
            e1=prev(e,D)
            e2=next(e,D)
            splitFace(e1,e2,D)
            if origin(prev(e2,D),D)<>origin(m,D):
                e=prev(e2,D)
            else:
                e=e2
        else:
            e=next(e,D)
            

            
def triangulation(p):
    n=len(p)
    P=[[i[1],i]for i in p]
    M=min(P)[0]  #punto de menor ordenada
    P=angularSort(p,M)
    D=dcel(P)
    for i in range(3,n):  #triangulacion de la cara acotada
        splitFace(n-i,n-1,D)
    DCELconvexHull(D)  #scan de Graham
    return D         

   
def triangulation(p):
    n=len(p)
    P=[[i[1],i]for i in p]
    M=min(P)[1]  #punto de menor ordenada
    P=angularSort(p,M)
    D=dcel(P)
    DCELconvexHull(D)  #scan de Graham
    for i in range(3,n):  #triangulacion de la cara acotada
        splitFace(n-i,n-1,D)
    
    return D

 


 
def flip(a,D):
    oa=D[1][a][0]
    ga=D[1][a][1]
    ca=D[1][a][4]
    aa=D[1][a][2]
    pa=D[1][a][3]
    cb=D[1][ga][4]
    ab=D[1][ga][2]
    pb=D[1][ga][3]
    oga=D[1][ga][0]
    D[1][a]=[D[1][aa][0],ga,pa,ab,ca]
    D[1][ga]=[D[1][ab][0],a,pb,aa,cb]
    D[1][pa][2]=ab
    D[1][pa][3]=a
    D[1][aa][2]=ga
    D[1][aa][3]=pb
    D[1][aa][4]=cb
    D[1][pb][2]=aa
    D[1][pb][3]=ga
    D[1][ab][2]=a
    D[1][ab][3]=pa
    D[1][ab][4]=ca
    D[2][ca]=a
    D[2][cb]=ga
    D[0][oa][1]=pb
    D[0][oga][1]=pa

    return
#flipable(a,D)
def flipable(a,D):
    if face(a,D)==0 or face(twin(a,D),D)==0:
        return false
    A,B,C,D = originCoords(a,D),originCoords(prev(twin(a,D),D),D),originCoords(twin(a,D),D),originCoords(prev(a,D),D)
    if sarea(A,B,C)>0 and sarea(B,C,D)>0 and sarea(C,D,A)>0 and sarea(D,A,B)>0:
        return True
    return false
#legal(a,D)
def legal(a,D):
    if flipable(a,D)==-1:
        return true
    A,B,C,D = originCoords(a,D),originCoords(prev(twin(a,D),D),D),originCoords(twin(a,D),D),originCoords(prev(a,D),D)
    if inCircle(A,C,D,B)==false:
        return True
    else:
        return False
#legalize(T)

def legalize(t):
    T=deepcopy(t)
    c=1
    vueltas=0
    flips=0
    while c>0:
        vueltas=vueltas+1
        c=0
        for i in range(len(T[1])):
            if legal(i,T)==-1:
                flip(i,T)
                flips=flips+1
                c=c+1
    print "num vueltas: ",vueltas,"num flips: ",flips
    return T

#delone(p)
    k=triangulation(p)
    k=legalize(k)
    return k

def infiniteVertex(e,D):
    A = originCoords(e,D)
    B = originCoords(next(e,D),D)
    v = vector(B)-vector(A)
    v0 = vector([-v[1],v[0]])
    v0 *= 100/v0.norm()
    M = midPoint(A,B)
    C = vector(M)+v0
    return list(C)

def voronoiRegion(i, D):
    F = vertexEdges(i,D)
    R = []
    for i in F:
        if face(i,D) != 0:
            A,B,C = originCoords(prev(i,D),D),originCoords(i,D),originCoords(next(i,D),D)
            R.append(circumcenter(A,B,C))
        else:
            R.append(infiniteVertex(i,D))
            R.append(infiniteVertex(prev(i,D),D))
    return R

def voronoi(D): #2n
    V=[]
    for i in range(len(D[0])):
        r = voronoiRegion(i,D)
        V.append(r)
    return V

# Calcula la distancia euclidea entre dos puntos
def dist(A,B):
    return sqrt((A[0]-B[0])**2+(A[1]-B[1])**2)
︡bd358066-1471-453a-8050-4947fe97fc90︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/188/tmp_7Fa2s9.svg","show":true,"text":null,"uuid":"91ece5bb-2248-4700-908a-d8bfb91a1215"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/188/tmp_BhZkvd.svg","show":true,"text":null,"uuid":"e8af788c-d95e-407b-b8ce-4c48bd997472"},"once":false}︡{"done":true}︡
︠42f4da48-20d5-4dbe-a506-6e7259f6da59s︠
# prueba
dist([0,0],[1,1])
︡127795d9-f16f-433e-8e1b-e015e6947fcb︡{"stdout":"sqrt(2)\n"}︡{"done":true}︡
︠bfc6b9bd-50a1-417c-8a1f-f9e3fc599168i︠
%html
<h3>2. <span id="cell_outer_0">cuadrado de la distancia entre los puntos</span></h3>

︡9104010b-c3a2-4f25-80d5-bff3eb0c164b︡{"done":true,"html":"<h3>2. <span id=\"cell_outer_0\">cuadrado de la distancia entre los puntos</span></h3>"}
︠ad880b5a-da3d-42ec-8ca8-a905b6903f7ds︠

# Si una distancia A es mayor que otra B haciendo la raiz cuadrada, sin la raiz cuadrada A seguirá siendo mayor que B sin la raiz, así evitamos tener que hacer la raiz cuadrada cuando tenemos que comparar distancias.
def dist2(A,B):
     return (A[0]-B[0])**2+(A[1]-B[1])**2
︡a7ecb1a0-ce2c-40d2-983b-12bd3ded9f28︡{"done":true}︡
︠9e22f4ae-df76-4a40-a095-2fa906e1c14fs︠
# prueba
dist2([0,0],[1,1])
︡7ccd6f78-cd1f-4fe6-9a74-71dd1a587f9d︡{"stdout":"2\n"}︡{"done":true}︡
︠226d7f8c-796f-4279-8277-203518c4e17fi︠
%html
<h3>3. <span id="cell_outer_0">area signada</span></h3>

︡2f47d8e3-e79c-407e-9b37-44c32bf4bb76︡{"done":true,"html":"<h3>3. <span id=\"cell_outer_0\">area signada</span></h3>"}
︠54128251-f9e2-4883-8ccd-09ab9dafdfa0s︠
# Nos calcula el area signada de los punto A, B y C con esa orientación. Siendo positiva si la orientación sigue el sentido antihorario , negativa en caso contrario y cero si los puntos están alineados.
def sarea(A,B,C):
    return (1/2)*((B[0]-A[0])*(C[1]-A[1])-(C[0]-A[0])*(B[1]-A[1]))
︡46deb9d4-10c8-4cf5-bee6-7306ceb5a747︡{"done":true}︡
︠550c4d75-e803-4e47-8d23-319655b69efbs︠
# prueba
sarea([1,1],[0,0],[1,0])
︡8201814d-a36c-42f4-857a-c46f45bfd7c0︡{"stdout":"1/2\n"}︡{"done":true}︡
︠2d4183c4-85a3-4fe3-9762-3dcded61d6aes︠
# prueba
sarea([1,0],[0,0],[1,1])
︡a6c26b2c-db03-412f-b887-92bf94ae23bd︡{"stdout":"-1/2\n"}︡{"done":true}︡
︠1523638c-ace7-4bf7-aeee-3a4f63580f48s︠
# Nos da el signo del area signada. Siendo -1 si va en sentido horario, 1 en sentido antihorario y 0 si están alineados.
def orientation(A,B,C):
    return sign((1/2)*((B[0]-A[0])*(C[1]-A[1])-(C[0]-A[0])*(B[1]-A[1])))
︡c41e29fb-3d51-493f-b5b6-b055600aa22f︡{"done":true}︡
︠733c688e-5fa4-4ff4-adf0-bc262714e57fs︠
#pruebas
orientation([0,0],[1,0],[0,-1]), orientation([1,0],[0,0],[-1,0]), orientation([1,1],[0,0],[1,0])
︡8aa07e85-4de2-4ace-bb8f-19760cb628af︡{"stdout":"(-1, 0, 1)\n"}︡{"done":true}︡
︠5c3f0b07-958f-42df-aa8c-ed4766afe6ebi︠
%html
<h3>5. <span id="cell_outer_0">punto medio de dos puntos</span></h3>

︡d3bd65f5-4dec-4ce9-9915-a3f494a94145︡{"done":true,"html":"<h3>5. <span id=\"cell_outer_0\">punto medio de dos puntos</span></h3>"}
︠ce0e2209-b336-4f0b-828b-0e3985677bd8s︠
# Calcula el punto medio de A y B.
def midPoint(A,B):
    return [((A[0]+B[0])/2),((A[1]+B[1])/2)]
︡b0ed11d9-0b6f-4819-8750-020b278c52a9︡{"done":true}︡
︠db0f6e89-3d79-4e88-9b73-48a8c91a30ads︠
#prueba
midPoint([2,4],[4,8])
︡d5d6abf2-5c84-4c81-9b99-0e5fc2c2efe9︡{"stdout":"[3, 6]\n"}︡{"done":true}︡
︠6e13b8e0-1e29-4cfe-a16f-aebdf9c82224s︠

#Primero comprobamos que la coordenada x de P esté entre las coordenadas x de los puntos que definen el segmento. 
#Después repetimos el mismo proceso para las coordenadas y.
#Por último comprobamos si están alineados calculando la orientación.
#Devolviendo True si el punto está en el segmento y False si no lo está.

def inSegment(P,s):
        if ((s[0][0]<=P[0]<=s[1][0] or s[1][0]<=P[0]<=s[0][0]) & (s[1][1]<=P[1]<=s[0][1] or s[0][1]<=P[1]<=s[1][1])):
            if orientation(P,s[0],s[1])==0:
                return True
            else:
                return False
        else:
            return False

︡54b285d5-fc46-414e-8206-e926b5c01fda︡{"done":true}︡
︠b7cc5571-1557-4d09-899e-8641ac33c2ces︠
︡0e8452a4-54bf-4806-866a-f53a26d32ecb︡{"done":true}︡
︠13943d45-ac73-4d29-a7eb-28422631e3dbs︠
#pruebas
inSegment([1,1],[[0,0],[2,2]]), inSegment([2,2],[[0,0],[2,2]]), inSegment([1.000000000000000000001,1],[[0,0],[2,2]])
︡dbac5b84-92eb-4dfb-968c-4f5e860e9cba︡{"stdout":"(True, True, False)\n"}︡{"done":true}︡
︠56fbf405-b103-4e97-a245-bde1a8b02de7i︠
%html
<h3>7. <span id="cell_outer_0">test de punto en tri&aacute;ngulo</span></h3>

︡a34f6006-0a7d-4cd4-b7a0-d62c10c4a986︡{"done":true,"html":"<h3>7. <span id=\"cell_outer_0\">test de punto en tri&aacute;ngulo</span></h3>"}
︠8ff766c0-60d6-488b-a6d6-710241a494d5s︠
#Calculamos las orientaciones del conjutno formado por  P y cada par distinto de vértices y si dan a la vez 1 y -1 quiere decir
#que el punto no pertenece al triángulo. Devuelve True si pertenece al triángulo y False en caso contrario.
def inTriangle(P,t):
    L=(orientation(t[0],t[1],P),orientation(t[0],P,t[2]),orientation(P,t[1],t[2]))
    if (1 in L and -1 in L): return False
    return True
︡d21c6fa6-adb8-4809-b4f9-6a2a1a8feba4︡{"done":true}︡
︠1f0e260f-7bc8-4b09-bd7e-aea7439c7affs︠
#pruebas
inTriangle([0,1],[[-2,0],[2,0],[0,2]]),inTriangle([1,1],[[-2,0],[2,0],[0,2]]),inTriangle([1,1.0000000000000000000000000000000000000000000001],[[-2,0],[2,0],[0,2]])

︡0a5eb8fd-8273-44fd-bf20-a7538eae4478︡{"stdout":"(True, True, False)\n"}︡{"done":true}︡
︠4e595317-2f2c-46c8-b1da-9f36b0ba57c0s︠
p= [1,1]
t=[[-2,0],[2,0],[0,2]]

g1=line([t[0]]+[t[1]]+[t[2]]+[t[0]],thickness=2,color="red")+point(p,size=50,color="blue")+text(inTriangle([0,1],[[-2,0],[2,0],[0,2]]), (1,2.5))

p= [0,1]
t=[[-2,0],[2,0],[0,2]]

g2=line([t[0]]+[t[1]]+[t[2]]+[t[0]],thickness=2,color="red")+point(p,size=50,color="blue")+text(inTriangle([0,1],[[-2,0],[2,0],[0,2]]), (1,2.5))

P=(random(),random())
t=[(random(),random()),(random(),random()),(random(),random())]

g3=point(P,color="red") + polygon (t)+text(inTriangle(P,t), (1,2.5))

graphics_array([[g1,g2,g3]]).show(figsize=[10,5])
︡b8a83093-83e9-44e2-b26a-c69e409a3e8e︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/405/tmp_zONe3u.svg","show":true,"text":null,"uuid":"08ff2ae8-3c7d-46db-a79a-9cf0eb64c56b"},"once":false}︡{"done":true}︡
︠a1e25f67-fdd0-4d8c-904c-31da66b8f2ba︠

︡76e9f302-1b4a-42ca-8cc2-2fe3177ab440︡
︠de4bb5ed-8949-476f-b9bc-30bd4153f4a4s︠
︡6388fb68-3c0a-40f2-b1d8-f34ee1767782︡{"done":true}︡
︠aebeca07-63c2-4d63-9102-de9f45629372s︠
P=(random(),random())
t=[(random(),random()),(random(),random()),(random(),random())]
print inTriangle(P,t)
point(P) + polygon (t)
︡a9b88314-7271-4d31-b584-c940e44ed948︡{"stdout":"False\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/250/tmp_lJrAfK.svg","show":true,"text":null,"uuid":"79c24509-f1c2-4f68-8006-c56bd2eaf39f"},"once":false}︡{"done":true}︡
︠5b37ecc4-4620-49c8-9d68-10ebf2654033i︠
%html
<h3>8. <span id="cell_outer_0">test de intersecci&oacute;n de dos segmentos</span></h3>

︡a81cc952-b7e3-4a09-b8a1-14dfa0ce1ad0︡{"done":true,"html":"<h3>8. <span id=\"cell_outer_0\">test de intersecci&oacute;n de dos segmentos</span></h3>"}
︠39920328-307c-4a88-a7c2-b827deb0e161︠
# Si se intersecan hay dos casos:
# -Se cortan en un punto que no es extremo de ningún segmento. Para ello hacemos la orientación de los extremos de un            segmento con cada uno de los extremos del otro.Si son distintas, hacemos el mismo paso pero invirtiendo los papeles. Si      vuelven a ser disntintas, quiere decir que se cortan en un punto.
# -Uno de los extremos de un segmento está contenido en el otro. Para ello usamos la función inSegment y vemos si se cortan o    no.

def segmentIntersectionTest(a,b):
    if (orientation(a[0],a[1],b[0])!=orientation(a[0],a[1],b[1])) & (orientation(b[0],b[1],a[0])!=orientation(b[0],b[1],a[1])):
        return True
    else:
        return inSegment(a[0],b) or inSegment(a[1],b) or inSegment(b[0],a) or inSegment(b[1],a)
︡45f96349-23a2-4f44-b20d-81efbbd631d6︡{"done":true}︡
︠4a26394e-b60e-4d2a-ae71-3f69cfd74302s︠
t1=segmentIntersectionTest([[0,0],[2,2]],[[2,0],[0,2]])
p11=line([[0,0]]+[[2,2]],color="cyan")+line([[2,0]]+[[0,2]],color="red")
t11= text(t1, (1,2))
p1=p11+t11

t22=segmentIntersectionTest([[0,0],[2,2]],[[1,1],[1.5,1.5]])
p22=line([[0,0]]+[[2,2]],color="cyan")+line([[1,1]]+[[1.5,1.5]],color="red")
t2= text(t22, (1,2))
p2=p22+t2

t33=segmentIntersectionTest([[0,0],[0,2]],[[0,1],[2,1]])
p33=line([[0,0]]+[[0,2]],thickness=3,color="cyan")+line([[0,1]]+[[2,1]],color="red")
t3=text(t33, (1,2))
p3=p33+t3

t44=segmentIntersectionTest([[0,0],[2,2]],[[2,2],[1,0]])
p44=line([[0,0]]+[[2,2]],color="cyan")+line([[2,2]]+[[1,0]],color="red")
t4= text(t44, (1,2))
p4= p44+t4

t55=segmentIntersectionTest([[0,0],[2,2]],[[0,-1],[2,1]])
p55=line([[0,0]]+[[2,2]],color="cyan")+line([[0,-1]]+[[2,1]],color="red")
t5= text(t55, (1,2))
p5= p55+t5

graphics_array([[p1, p2,p3, p4,p5]]).show(figsize=[10,4])
︡ec14fd94-54a3-46da-a461-c2607328a36f︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/2175/tmp_9bhoD1.svg","show":true,"text":null,"uuid":"a6917b08-0b78-4bd4-8dc7-0af7ddc0e4d2"},"once":false}︡{"done":true}︡
︠366dcce4-cc39-46c8-861f-a6343b8acb5ai︠
%html
<h3>9. <span id="cell_outer_0">punto de intersecci&oacute;n de dos rectas</span></h3>

︡9d4ae378-9db7-4505-9386-4f0f7a6277c0︡{"done":true,"html":"<h3>9. <span id=\"cell_outer_0\">punto de intersecci&oacute;n de dos rectas</span></h3>"}
︠6ed6c7b2-60d7-44f0-8c37-680101318102s︠
# Sacamos los vectores de cada recta. Comprobamos si el determinante de esos dos vectores es cero, sino lo es se cortan en un punto. Hallamos el punto resolviendo el sistema Ax=b.
def lineIntersection(r,s):
    A=vector(r[0])
    B=vector(r[1])
    C=vector(s[0])
    D=vector(s[1])
    AB=B-A
    CD=D-C
    if(det(matrix([AB,CD]))==0):
     
        return
    else:
        AA=matrix([[A[1]-B[1],B[0]-A[0]],[C[1]-D[1],D[0]-C[0]]])
        bb=vector([A[1]*B[0]-A[0]*B[1],C[1]*D[0]-C[0]*D[1]])
        return list(AA\bb)

︡3f636444-2c6c-41ac-bc93-3065868b81e4︡{"done":true}︡
︠e641475e-dbec-4702-b4f8-c0f2bea09dd8︠
︡4002a202-dc0b-4218-96f3-190c08ac7e68︡
︠0e453265-5072-4f3e-9aa6-f38d5c928dfc︠
︡9a6213ac-5d6e-467a-baca-1a6ea6b2c3b5︡
︠e07248e7-71b8-4512-8429-962809d64854︠
# pruebas
punto=lineIntersection([[0,0],[2,2]],[[2,0],[0,2]])
s1=line([[0,0]]+[[2,2]],color="cyan")+line([[2,0]]+[[0,2]],color="gold")+point(punto,color="red")+text(lineIntersection([[0,0],[2,2]],[[2,0],[0,2]]), (1,2))

punto=lineIntersection([[0,0],[40,40]],[[0,1],[40,44.99]])
s2=line([[0,0]]+[[40,40]],color="cyan")+line([[0,1]]+[[40,44.99]],color="gold")+point(punto,color="red")+text(lineIntersection([[0,0],[40,40]],[[0,1],[40,44.99]]), (30,40))

s3=line([[0,0]]+[[2,2]],color="cyan")+line([[0,1]]+[[2,3]],color="gold")+text(lineIntersection([[0,0],[2,2]],[[0,1],[2,3]]), (1,3))
graphics_array([[s1, s2,s3]]).show(figsize=[10,6])
︡da0a6ce9-17cd-48bb-8a97-8f6913cbce4e︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/405/tmp_OUfcWe.svg","show":true,"text":null,"text":null,"uuid":"c58347b8-f625-4803-85e9-538bbdfc2dca"},"once":false}︡{"done":true}︡︡
︠448d8790-6db0-4a85-9e19-44e05307a663s︠
lineIntersection([[0,0],[2,2]],[[1,1],[3,3]])
︡d8eb1af3-e108-43af-aa54-05e044eb43bd︡{"stdout":"no se cortan en un punto\n"}︡{"done":true}︡
︠2f49d6d4-4e2c-4aa2-83ea-7251db944ec3s︠
r=[[random(),random()],[random(),random()]]
s=[[random(),random()],[random(),random()]]
line(r,aspect_ratio=1)+line(s)+point(lineIntersection(r,s),color="red",size=20)
︡60617956-a13c-4b4d-92fe-050479c62cc7︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/123/tmp_2RA7Qh.svg","show":true,"text":null,"uuid":"a101e56e-af2d-4695-b026-973fe10e204d"},"once":false}︡{"done":true}︡
︠cdbac4ef-a965-4ecc-aede-8d630fc41e6ci︠
%html
<h3>10. <span id="cell_outer_0">test de inclusi&oacute;n del punto en c&iacute;rculo</span></h3>

︡5b6cf99e-e29e-4a63-8d9e-8839b7e8f158︡{"done":true,"html":"<h3>10. <span id=\"cell_outer_0\">test de inclusi&oacute;n del punto en c&iacute;rculo</span></h3>"}
︠bb33484c-cf20-4be0-8ac6-9ea7cba3499fs︠
# Calcula el volumen signado de 4 punto en tres dimensiones. Siendo positivo si la orientación es en sentido antihorario, negativa en sentido horario y cero si están alienados.
def svolume(a,b,c,d):
    Ap = [a[0],a[1],a[0]**2+a[1]**2,1]
    Bp = [b[0],b[1],b[0]**2+b[1]**2,1]
    Cp = [c[0],c[1],c[0]**2+c[1]**2,1]
    Dp = [d[0],d[1],d[0]**2+d[1]**2,1]
    M =matrix([Ap,Bp,Cp,Dp])
    return M.det()
︡17b5ab3c-a69b-4c11-9bfc-50b554e6ff58︡{"done":true}︡
︠38902e4b-bc93-49fb-951b-ca3dec577fa5s︠
svolume([1,2],[1,0],[1,4],[5,4])


︡eac5e64c-00e7-49ec-a2c0-7140bcf611e4︡{"stdout":"64\n"}︡{"done":true}︡
︠3d03658e-4523-4b86-b45e-5991100a4b45s︠
svolume([0,2],[1,2],[2,2],[3,2])
︡e61627ce-488e-4305-a715-59b8f25bc779︡{"stdout":"0\n"}︡{"done":true}︡
︠70ed61a5-d993-4dfc-812a-124a1fbf3866s︠
#incircle test. Entrada cuatro puntos a,b,c,d y salida 1, -1 o 0 dependiendo de que el punto d sea interior, exterior o este en la frontera del circulo que determinan a,b y c.


def inCircle(a,b,c,d):
    if (sarea(a,b,c) == 0):
        print ("error")
        return
    elif ((sarea(a,b,c)*svolume(a,b,c,d))>0):

        return int(1)
    elif ((sarea(a,b,c)*svolume(a,b,c,d))==0):

        return int(0)
    else:
        return int(-1)

︡9b9c045a-7c5a-4a11-9094-1be27960c3c8︡{"done":true}︡
︠39b9373e-4e24-4303-bcd4-c7dbc17f06ce︠

︡291b8bb9-917e-4319-aeee-0c68658f7406︡
︠0aa57025-b3e2-4447-a571-fda1dcf30307s︠
def circulo3puntos(a,b,c):
    centro=circumcenter(a,b,c)
    radio2=dist(centro,a)
    return circle(centro,radio2,color="cyan")+point(a,color="red",size=30)+point(b,color="red",size=30)+point(c,color="red",size=30)
︡795c23b3-90a0-4ff1-96a5-111a47591721︡{"done":true}︡
︠14b9033d-3ea0-495e-827c-f5f935f0679d︠
# pruebas

c1=circulo3puntos([0,0],[0,2],[2,0])+point([1,1],color="black",size=30)+text(inCircle([0,0],[0,2],[2,0],[1,1]), (1,4))

c2=circulo3puntos([-1,0],[1,1],[0,1])+point([-1,-1],color="black",size=30)+text(inCircle([-1,0],[1,1],[0,1],[-1,-1]), (1,2))



c3=circulo3puntos([0,0],[0,2],[2,0])+point([5,5],color="black",size=30)+text(inCircle([0,0],[0,2],[2,0],[5,5]), (3,5))
graphics_array([[c1, c2,c3]]).show(figsize=[10,6])
︡94ca11c1-f4c2-4d62-8fe7-0331d80532ba︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/180/tmp_vrpVR5.svg","show":true,"text":null,"uuid":"0532c27d-dcb2-4f9e-aa90-feeabebceceb"},"once":false}︡{"done":true}︡
︠99450643-2ae1-4859-8fcf-5af845482bc0s︠
︡6e27f624-63bb-49fb-b9aa-979b8a54c9b6︡{"done":true}︡
︠dd4b4880-fbca-4f4a-bfcc-ae8f19e50d8b︠
︡8faddc84-608c-4fc9-a7e2-48c8e545332f︡
︠b7de47c2-0fc1-4eeb-9f32-8b9611f1358f︠
︡01f403ba-6a20-411a-a27c-1e853f6ae23e︡
︠90a5fbd5-9562-4bbd-92ce-ee4b9eccb551s︠
# A continuación comprobamos el caso en el que los tres puntos estan alienados
inCircle([0,0],[0,2],[0,4],[3,3])

︡c240c763-11c8-4a0e-b1a8-b572499a9a36︡{"stdout":"error\n"}︡{"done":true}︡
︠ce7b5fe9-562d-42f5-b8d0-75abbbbd32cbi︠
%html
<h3>11. <span id="cell_outer_0">circuncentro del c&iacute;rculo determinado por tres puntos</span></h3>

︡7e14c420-9767-4b92-8abf-9d785fa37a0e︡{"done":true,"html":"<h3>11. <span id=\"cell_outer_0\">circuncentro del c&iacute;rculo determinado por tres puntos</span></h3>"}
︠f60c6286-f9a4-42aa-8b6b-080bb9868866s︠
#Devulve el circuncentro de tres puntos.Primero comprobamos que no estén alineados y luego utilizamos la fórmula del circuncentro.
def circumcenter(a,b,c):
    sa=sarea(a,b,c)
    if (sa==0):
        print ("alineados")
        return
    cx=matrix([[1,1,1],[a[1],b[1],c[1]],[a[0]**2+a[1]**2,b[0]**2+b[1]**2,c[0]**2+c[1]**2]]).det()/(-4*sa)
    cy=matrix([[1,1,1],[a[0],b[0],c[0]],[a[0]**2+a[1]**2,b[0]**2+b[1]**2,c[0]**2+c[1]**2]]).det()/(4*sa)
    return [cx,cy]
︡fda3817f-0852-4172-89a9-f14937aa3149︡{"done":true}︡
︠58515df6-a780-47f7-a2d5-fc4d914b1e48s︠
# pruebas

c1=circulo3puntos([0,0],[1,0],[1,1])+point(circumcenter([0,0],[1,0],[1,1]),color="green",size=30)
c1

︡8651ab9e-b870-4c15-918c-9617d1b006e1︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/145/tmp_fByOSa.svg","show":true,"text":null,"uuid":"80172de7-15b4-4dbb-ac8b-56df0bcedad2"},"once":false}︡{"done":true}︡
︠76acf04b-dc81-45f2-82d9-07fbdf0889d0s︠
circumcenter([-1,0],[0,1],[1,0])
︡b9ce2b71-cd8f-4bba-950a-acb3d8cfeca0︡{"stdout":"[0, 0]\n"}︡{"done":true}︡
︠da68405f-399a-4a7d-8f3b-e421fba56837s︠
circumcenter([0,0],[1,0],[2,0])
︡cc9d7ea9-93ba-4e77-a37b-97389baee743︡{"stdout":"alineados\n"}︡{"done":true}︡
︠a7c639f7-2b57-4397-bd87-498d7e25af37︠

︡f76b860d-594b-40c3-ab86-e25c154e7795︡
︠f71d1893-fca5-4528-a4f3-b624f88576cb︠
# 






#                                                ORDENACION GEOMETRICA







︡08422940-8ecc-42ad-97f5-71de2e28a3f5︡{"done":true}︡
︠d03115eb-3292-4972-a2d3-6c77c3ebf00c︠
#1.- Ordenar una lista de números de menor a mayor.
︡9573c73a-db93-4cc8-8ad7-96b6c70f81cd︡
︠23974baa-15c7-40b3-86a2-dbf5d4313a52i︠
︡90475f56-32b0-44b3-8487-1feebd574ca4︡{"done":true}︡
︠5dc1a8ea-b9e7-4a73-9e7f-9f5aafa09dffs︠
# Ordena una lista de número de menor a mayor. Empleando la estrategia de divide y vencerás.
def mergeSort(alist):
    
    if len(alist)>1:
        mid = len(alist)//2
        lefthalf = alist[:mid]
        righthalf = alist[mid:]

        mergeSort(lefthalf)
        mergeSort(righthalf)

        i=0
        j=0
        k=0
        while i < len(lefthalf) and j < len(righthalf):
            if lefthalf[i] < righthalf[j]:
                alist[k]=lefthalf[i]
                i=i+1
            else:
                alist[k]=righthalf[j]
                j=j+1
            k=k+1

        while i < len(lefthalf):
            alist[k]=lefthalf[i]
            i=i+1
            k=k+1

        while j < len(righthalf):
            alist[k]=righthalf[j]
            j=j+1
            k=k+1
    return alist
︡70997b3c-f5d3-4cd6-ba0d-3dc439055c1d︡{"done":true}︡
︠f1ba3c06-454d-4a4d-9bb0-55f14db21ee6s︠
L=[0,1,6,8,4,22,15,39,47,2,2,5,9,47]
L1=[0,1,6,8,4,22,15,39,47,2,2,5,9,47]
︡df413431-ec0f-4819-a20f-d142e2ba7a11︡{"done":true}︡
︠0a055844-5435-4d95-b5e5-3f2c4c77ad6bs︠
print(sorted(L1))
print(mergeSort(L))

︡e5b973c0-e091-4d58-b5da-40953a7aa105︡{"stdout":"[0, 1, 2, 2, 4, 5, 6, 8, 9, 15, 22, 39, 47, 47]\n"}︡{"stdout":"[0, 1, 2, 2, 4, 5, 6, 8, 9, 15, 22, 39, 47, 47]\n"}︡{"done":true}︡
︠61a3a790-e8fe-4c89-994d-f062cccfa418s︠
︡178f4661-a30c-4dc1-9ccf-cfe883e65256︡{"done":true}︡
︠1df6d425-5ef2-4145-854f-6f23e9843fa3s︠
#2.- Ordenar una lista de números de menor a mayor, sabiendo que se encuentra ordenada de mayor a
#menor.
︡3a09fb5d-6552-4c98-a43d-c0a7cca74dad︡{"done":true}︡
︠820f975c-788b-4ed2-8b8a-6c8a39f8688as︠
# Como sabemos que está ordenada de mayor a menor, solo hay que darle la vuelta con reverse.
def ejercicio2(L):
    L.reverse()
    return L
︡4d6a31d0-7e47-427c-b69d-53cfd9657e4f︡{"done":true}︡
︠7bff1f96-cfad-4a20-84ce-5aa7f3630830s︠
L=[22,21,20,19,18,17,15,14,12,13,10,9,5,4,1]
print(ejercicio2(L))

︡5dab1c22-62e9-4b42-a38c-5a0f684da230︡{"stdout":"[1, 4, 5, 9, 10, 13, 12, 14, 15, 17, 18, 19, 20, 21, 22]\n"}︡{"done":true}︡
︠95ff9307-904b-430f-b77c-433680ec0fec︠
︡82be0741-300e-486b-a79c-63371268a96b︡
︠f4f282ec-4ba7-4b3c-8221-b0072baafc80︠
︡493bb1b6-263d-465c-89aa-10454c2e796e︡
︠1493bae1-eae7-4aca-aebe-c64203f6b6efs︠
#Concatenamos las dos listas y le aplicamos el metodo mergeSort
def ejercicio3(L1,L2):
    L1.extend(L2)
    mergeSort(L1)
    return L1
︡28ea4e44-42af-48a4-8bdb-3b832c6a89bb︡{"done":true}︡
︠eed5d803-5c19-45d3-961b-44af50b959d5s︠
L1=[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18]
L2=[7,8,9,10,11,12,13,14,15,16]
print(ejercicio3(L1,L2))
︡b99c7b31-c743-472a-a91d-f7bc5a9c3135︡{"stdout":"[1, 2, 3, 4, 5, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 16, 16, 17, 18]\n"}︡{"done":true}︡
︠acb7e5ad-d993-443e-a13c-957128b1f95di︠
%html
<p><strong>Dimensi&oacute;n 2:</strong><br />Dada una lista de n puntos del plano por sus coordenadas cartesianas,</p>
<p>4.- Ordenar lexicogr&aacute;ficamente seg&uacute;n sus coordenadas cartesianas los n puntos.</p>

︡8cf5144e-f0bf-4d38-ad03-2f98adfab618︡{"done":true,"html":"<p><strong>Dimensi&oacute;n 2:</strong><br />Dada una lista de n puntos del plano por sus coordenadas cartesianas,</p>\n<p>4.- Ordenar lexicogr&aacute;ficamente seg&uacute;n sus coordenadas cartesianas los n puntos.</p>"}
︠864e57c6-0c76-4c6f-b911-47a3b376696b︠

︡4fbfabc8-21bb-4f25-ae1c-8ebe24b5f0f9︡{"done":true}︡
︠3cf239fb-5142-44e4-b5b5-d6c87cf07f08s︠
# Tan solo hay que hacer un sorted de la lista
def ejercicio4(p):
    return sorted(p)
︡391e2e9e-aeb1-4737-86b5-30ea0006121a︡{"done":true}︡
︠e807b66b-e30c-4aed-bc33-9a12455d9e3as︠
L=[[1,1],[2,2],[81,0],[2,3],[35,0],[5,0],[7,0],[1,0],[9,0],[2,0],[4,0],[3,0]]
print(ejercicio4(L))
︡58f8b1cd-114a-468f-9329-935dac0cf698︡{"stdout":"[[1, 0], [1, 1], [2, 0], [2, 2], [2, 3], [3, 0], [4, 0], [5, 0], [7, 0], [9, 0], [35, 0], [81, 0]]\n"}︡{"done":true}︡
︠b3776f24-3d08-40d4-a5f2-ad23a0733449s︠

︡03a8a4e3-44f1-4943-99ea-8109b13f8111︡{"done":true}︡
︠10dadba4-5463-4ea8-9a19-4b87ded4e20di︠
%html
<p>5.- Ordenar los puntos seg&uacute;n la direcci&oacute;n de un vector dado.</p>

︡fefa08c4-65bc-46c5-93ac-d1c6eaf3f4fd︡{"done":true,"html":"<p>5.- Ordenar los puntos seg&uacute;n la direcci&oacute;n de un vector dado.</p>"}
︠07b04ae6-a0fd-4639-bab7-9b771c6df035︠
def sortv(p,v):
    
    return
︡284ff596-3379-4403-9e0d-0925eda2af1f︡︡
︠4c735784-db28-4477-82b3-4fba30acfe0fi︠
%html
<p>6.- Ordenar los puntos angularmente respecto de un punto dado</p>

︡6db90b66-6797-4e43-9269-d9473da26ec7︡{"done":true,"html":"<p>6.- Ordenar los puntos angularmente respecto de un punto dado</p>"}
︠0538f912-558f-4106-860a-8c6b665eef56︠

def angularSort(p,c):
    def compare(p,q):
        if p==q:
            return int(0)
        if p[1]>c[1]>=q[1]:
            return int(1)
        elif q[1]>c[1]>=p[1]:
            return int(-1)
        elif orientation(c,p,q)==1:
            return int(1)
        elif orientation(c,p,q)==-1:
            return int(-1)
        elif dist2(c,p)<dist2(c,q):
            return int(1)
        else:
            return int(-1)
    
    q=deepcopy(p)
    q=sorted(q,cmp=compare)  
    q.reverse()
    return q
︡6efe0a10-b5d1-4fb5-829d-e0faf846c3f8︡
︠ed99d814-737d-4f63-aa9e-00932fba634d︠



︡989881e1-bf39-48e4-8d84-e8cfbbb487db︡
︠04504ce6-9a7d-4104-bc59-e8037fd771cc︠
p=[[int(10*random()),int(10*random())]for i in range(50)]
line(p+[p[0]])+point(p[0],color="red")
a=angularSort(p,p[0])

line(a+[a[0]])+point(p[0],color="red")



︡5e7b4fd0-425e-491b-b2c9-54c35479593d︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/123/tmp_FXomCV.svg","show":true,"text":null,"uuid":"a25f7c8f-d303-4b95-b53e-e0af5acaeba9"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/123/tmp_7u3t50.svg","show":true,"text":null,"uuid":"b3993565-c980-4560-bf54-eb2f75be9f04"},"once":false}︡{"done":true}︡
︠53aa02a8-eca8-4bfd-a1dd-a05dc0b2f740︠

︡1513b194-621b-42a0-b00f-00d086c39ffa︡
︠8d03da22-5540-49ca-962b-d2ca94646085︠
                                                    POLIGONIZACION
︡ce8d7a09-1998-4710-8851-8036b7a45243︡{"done":true}︡
︠ab329a49-670d-4b64-bcab-54db63af5de1s︠
# poligonizacion X-monotona
#cogemos los puntos máximo y mínimo de la lista de puntos y a partir de ellos 
#dividimos los puntos en dos listas según el área signada respecto de estos dos puntos.
#Ordenamos ambas listas y unimos.
def polygonization(p):
    U=[]
    L=[]
    #Buscamos el valor max y min de p
    maxim=max(p)
    minim=min(p)
    for i in range(len(p)):
        if sarea(maxim,p[i],minim)>=0: U.append(p[i])
        else: L.append(p[i])
    U= sorted(U)
    L= sorted(L)
    U.reverse()
    return L+U       
    
# poligonizacion estrellada
# cogemos el punto medio de la lista de puntos y aplicamos angularsort

def starPolygonization(p):
    C=midPoint(p[0],p[1])
    return angularSort(p,C)
︡7fa1ecb2-aad1-45bf-92bd-a06f1b66c117︡{"done":true}︡
︠7de2f57d-9e0d-427d-a0bb-7581cec1bd32︠

︡57cd89fb-0c04-482d-b814-34ac4c895a00︡{"done":true}︡
︠7730e2e9-04cc-4dab-bf69-6df025ed9a3as︠
p = [[random(),random()] for i in range(50)]
Pol = polygonization(p)
point(Pol,color="red")+line(Pol+[Pol[0]])+point([p[0],p[1]], color ="green", size=20)
︡5df84a5c-3301-42b0-bdb8-6ffd02363b3c︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/145/tmp_H27yoc.svg","show":true,"text":null,"uuid":"73a05928-bd5c-46a4-ab9c-63c65e4c51b4"},"once":false}︡{"done":true}︡
︠b38b83f9-008c-4c1a-96e7-73a5e8e6b6ees︠
p = [[random(),random()] for i in range(50)]
Pol = starPolygonization(p)
point(Pol,color="red")+line(Pol+[Pol[0]])+point([p[0],p[1]], color ="green", size=20)
︡0707520f-16f5-4b1c-8fca-68524e2184ae︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/250/tmp_PdLgIt.svg","show":true,"text":null,"uuid":"3c73a4be-9fe6-46f0-86ff-991003daa67c"},"once":false}︡{"done":true}︡
︠50826ee5-b35d-4129-b1af-a881dac2c14f︠
︡6ab57cfc-17c3-414f-affb-0fc04548dfd4︡
︠9bcb2e17-0d2a-455b-937b-8cf1c64b2e97︠

︡c6f8d2bb-e92c-4960-82cc-4703ddfb5a52︡{"done":true}︡
︠1611088c-d710-41a1-b0ed-e05eb8b28eees︠
#Le pasamos un poligono y una recta sobre la que se hará el corte. El resultado es el polígono formado por el corte de la recta sobre el anterior polígono.
# Primero hallamos el area signada para todos los puntos.
# -Si el area signada con la recta es mayor o igual que cero, añadimos el punto. Ahora nos fijamos en el siguiente punto, si    el area signada con la recta es negativo, quiere decir que la recta que une el punto anterior con el actual, corta a la      recta. Calculamos el punto de intersección y le añadimos a la lista de puntos.
# -Sino era mayor, quiere decir que está por debajo. Hallamos el sarea del siguiente y si es positivio, añadimos el punto de interseccion de la recta definida por los puntos y la recta de corte inicial.
def clipping(P,r):
    n=len(P)
    L=[]
    for i in range(n):
        if sarea(r[0],r[1],P[i])>=0:
            L.append(P[i])
            if sarea(r[0],r[1],P[(i+1)%n])<0:
                M=lineIntersection(r,[P[(i+1)%n],P[i]])
                L.append(M)
        elif sarea(r[0],r[1],P[(i+1)%n])>=0:
            N=lineIntersection(r,[P[(i+1)%n],P[i]])
            L.append(N)
    return L
︡8c9dd246-6558-4723-91ba-4d22971ab630︡{"done":true}︡
︠de867eb6-d224-494a-9abc-2be0a5ad3622s︠

p = [[random(),random()] for i in range(50)]
Pol = starPolygonization(p)
r=[[random(),random()],[random(),random()]]
CP=clipping(Pol,r)
polygon(CP,alpha=.5)+polygon(Pol,alpha=.5,color="cyan")+line(r,thickness=1,color="red")
︡a16283c5-38ae-422e-bc2d-a528f15164b7︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/250/tmp_tapBoc.svg","show":true,"text":null,"uuid":"0e885a67-22df-4f23-97cc-dcdeb4d75810"},"once":false}︡{"done":true}︡
︠8646078a-a7ed-47c7-be33-f6aea0e46c92︠

︡195cfd1e-d434-4047-8518-1f073eb4ffe7︡
︠f4d3980d-76d5-4f2f-af6c-441b5e1ac403i︠
%html
<h2><span id="cell_outer_2">3. Dado un pol&iacute;gono, obtener una oreja. </span></h2>
<p><span id="cell_outer_2">(Un v&eacute;rtice de un pol&iacute;gono se llama oreja si con sus dos v&eacute;rtices adyacentes forman un tri&aacute;ngulo contenido en el pol&iacute;gono que no contiene a ning&uacute;n otro v&eacute;rtice del mismo).<br /></span></p>

︡0ed931f0-0799-47f0-99b0-7a665f122138︡{"html": "<h2><span id=\"cell_outer_2\">3. Dado un pol&iacute;gono, obtener una oreja. </span></h2>\n<p><span id=\"cell_outer_2\">(Un v&eacute;rtice de un pol&iacute;gono se llama oreja si con sus dos v&eacute;rtices adyacentes forman un tri&aacute;ngulo contenido en el pol&iacute;gono que no contiene a ning&uacute;n otro v&eacute;rtice del mismo).<br /></span></p>"}︡
︠794a19fc-890f-4605-ab42-4b0bb39b7ffd︠

︡8072ce37-51da-4476-ac42-92dd55146e67︡︡
︠86e75199-b153-4004-b6e2-1e58ee1a229ei︠
%html
<h3>C&aacute;lculo de una oreja en tiempo lineal</h3>

︡673a9791-fb40-4923-92e5-b078f7073662︡{"html": "<h3>C&aacute;lculo de una oreja en tiempo lineal</h3>"}︡
︠8cddfe42-2482-41a5-a045-61da9b122c2fs︠
### funcion auxiliar que detecta si un vértice es oreja en tiempo O(n)
# Primero escogemos un punto.
# Después calculamos el area signada del anterior a ese punto, el punto y el siguiente. Si es negativa o iguala cero, no es     oreja.
# Si lo anterior no era cierto, aún queda por comprobar que ningún vértice del polígono esté dentro del triángulo que forman.   Si ninguno de los puntos estaba dentro, es un vértice oreja.
def earTest(P,i):
    n=len(P)
    if sarea(P[i-1],P[i],P[(i+1)%n])<=0:return False
    j=0
    while j<n:
            if j in [(i-1)%n,i,(i+1)%n]:j+=1
            else:
                if inTriangle(P[j],[P[i-1],P[i],P[(i+1)%n]]):return False
                else:
                    j+=1
    return True
# devolver el indice del vertice oreja
# Aplicamos el test anterior a todos los puntos del polígono y si alguno es oreja, imprimimos el indice de la primera oreja     encontrada.
def ear(P):
    n=len(P)
    a=0
    m=0
    while(a<n)and(m==0):
        if (earTest(P,a))==True: m=1
        else:a=a+1
        
    return a
            
 
︡42fe264a-8d77-49ef-86a3-69d0cfeb280d︡{"done":true}︡
︠9e4c8c94-cbfb-442a-ad91-37e7b2bb43e9s︠
p = [[random(),random()] for i in range(50)]
P = starPolygonization(p)
i=0
earTest(P,ear(P))
polygon(P,alpha=.5,color="red")+point(P[ear(P)],size=30,color="green")+line([P[ear(P)-1]]+[P[ear(P)]]+[P[(ear(P)+1)%len(P)]]+[P[ear(P)-1]],color="blue")
︡0f943f10-3ce9-4b70-8bc5-27e1a42aa275︡{"stdout":"True\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/354/tmp_eTQyQo.svg","show":true,"text":null,"uuid":"fd196dd4-8021-4ba5-9a26-0db335945af3"},"once":false}︡{"done":true}︡
︠c38eb8ed-bbbd-4ff3-a8cf-80900a54cf78︠

︡aa7d113f-5bc7-4dc3-8e93-224aa5912d0a︡
︠cc08454f-8af8-4530-ba43-013950264bc3︠

︡5a47f11e-0535-4aaa-bdbc-3d40aa7e0f2f︡
︠3c46ffd5-888e-4301-a420-b90c231beee8s︠
p = [[random(),random()] for i in range(20)]
P = starPolygonization(p)
i=0
earTest(P,i)
polygon(P,alpha=.5,color="red")+point(P[i],size=30,color="green")+line([P[i-1]]+[P[i]]+[P[(i+1)%len(P)]]+[P[i-1]],color="blue")
︡07c7af46-feed-4f00-82ab-12a37d2ec9ec︡{"stdout":"False\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/354/tmp_HBW7q3.svg","show":true,"text":null,"uuid":"34acea83-617c-4ac1-a850-8a1f3f61c8c2"},"once":false}︡{"done":true}︡
︠05d2e0a2-c88e-4120-ade0-3436fd95fc87︠

︡d72e79e9-32bc-405b-adc4-e051f9430596︡
︠ede1c3b4-e407-4235-aa7b-8c37aa0b5109i︠
%html
<h2><span id="cell_outer_2">4. Triangulaci&oacute;n por otectom&iacute;as sucesivas: </span></h2>
<p><span id="cell_outer_2">Dado un pol&iacute;gono, descomponerlo en tri&aacute;ngulos (triangularlo) iterando el c&aacute;lculo de orejas en el pol&iacute;gono que resulta de eliminar una de ellas. <br /></span></p>

︡9344f952-002e-433b-b248-3e351336a626︡{"html": "<h2><span id=\"cell_outer_2\">4. Triangulaci&oacute;n por otectom&iacute;as sucesivas: </span></h2>\n<p><span id=\"cell_outer_2\">Dado un pol&iacute;gono, descomponerlo en tri&aacute;ngulos (triangularlo) iterando el c&aacute;lculo de orejas en el pol&iacute;gono que resulta de eliminar una de ellas. <br /></span></p>"}︡
︠fca083d9-d179-4acd-9ad4-5cca08faf0c4s︠
# Hacemos una copia del poligono
# Buscamos una oreja y metemos en la lista un vector con los vertices de la oreja. A continuación eliminamos el vértice oreja   y repetimos este paso hasta que solo queden 3 vertices(vertices necesarios para formar un triángulo) y los añadimos           también.
def otectomyTriangulation(P):
    p=deepcopy(P)
    T=[]
    n=len(p)
    while n>3:
        e=ear(p)
        T.append([p[e-1],p[e],p[(e+1)%n]])
        del p[e]
        n -= 1 
    T.append(p)
    return T

︡b3278c48-724b-4043-a1c4-f7b62a2a1127︡{"done":true}︡
︠311c46d0-043e-4090-8881-e7c98038fc80s︠
p = [[random(),random()] for i in range(20)]
P = polygonization(p)
T=otectomyTriangulation(P)
sum(polygon(i,color=(random(),random(),random())) for i in T)+line(P+[P[0]])
︡39d5a008-8661-4d6c-bd0a-06b18ccf4e6f︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/354/tmp_TTF7cD.svg","show":true,"text":null,"uuid":"e05f49a6-b176-4acd-acb0-b194db9f1b48"},"once":false}︡{"done":true}︡
︠111eaf6d-1fd4-4444-945c-970eff5ee287i︠
%html
<h2>Pruebas</h2>

︡0ae0fe2e-5620-42e6-9cf4-f9b538ba15fd︡{"html": "<h2>Pruebas</h2>"}︡
︠3b9a05b4-d705-4624-96e2-33331aea1c37i︠
%html
<h2><span id="cell_outer_2">5. Dado un pol&iacute;gono, hallar una diagonal interna en tiempo lineal.<br /></span></h2>

︡efcbbdc4-2414-41f9-a5cf-e1462519287c︡{"html": "<h2><span id=\"cell_outer_2\">5. Dado un pol&iacute;gono, hallar una diagonal interna en tiempo lineal.<br /></span></h2>"}︡
︠51d1324b-f02c-4af5-ba28-4d80fe15a24as︠
# solucion 1: con la funcion ear(P)

def diagonal_1(P):
    n=len(P)
    a=ear(P)
    
    return [P[a-1],P[(a+1)%n]]
︡62261a71-398f-42ad-b80f-877a31fd746c︡{"done":true}︡
︠0545c879-ddf7-40f3-8756-5c13c190aa26s︠
p = [[random(),random()] for i in range(20)]
Pol = polygonization(p)
b=diagonal_1(Pol)
point(Pol,color="blue")+line([b[0]]+[b[1]],color="red")+line(Pol+[Pol[0]],color="purple")
︡d28c3e5f-d812-4737-8cd8-6c83b62dbd54︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/354/tmp_jfL3ZT.svg","show":true,"text":null,"uuid":"79b4e761-1644-46f6-989d-d4d26ea6eec8"},"once":false}︡{"done":true}︡
︠9b4ee10c-1327-406c-a6c8-dd29861184bd︠

︡f8c9c319-1338-4c48-b8f0-30b03bbc4231︡
︠d8875098-183b-4d76-9f57-1cca05c10f5d︠

︡04aa693c-5314-4850-a564-01dc2cca605e︡︡
︠67dd375d-54c7-4cdd-8d04-008269a54703︠

        


︡31b41c7e-2299-461f-a66a-f374f0f13546︡
︠7fd67d07-0f8e-459b-8e1c-79a79e13724as︠
#Fuerza bruta búsqueda de vértices
# Tenemos que hallar los puntos interiores. Para ello hacemos todas las combinaciones posibles de 3 puntos y vamos probando con los restantes si son interiores al triangulo que forman. Así conseguimos una lista con puntos interiores y los restantes seran los puntos de la envolvente. Elegimos la ordenacion angular para hacer al envolvente.
def convexHullBF1(p):
    n=len(p)
    interiores=[]
    for i in Combinations(n,3):
        for j in range(n):
            if j <> i[0] and j <> i[1] and j <> i[2] and inTriangle(p[j],[p[i[0]],p[i[1]],p[i[2]]]):
                if j not in interiores:
                    interiores.append(j)
    C=[]               
    for i in range(n):
        if i not in interiores:
            C.append(i)
    CH=[p[i] for i in C]
    M=midPoint(CH[0],CH[1])
    CH=angularSort(CH,M)
    return CH
︡9c0de525-50e8-4e00-8639-66b0ea8fbbd1︡{"done":true}︡
︠defc86d6-976a-4c35-9f34-5e340db78605s︠
p=[[random(),random()] for i in range(100)]
C=convexHullBF1(p)
line(C+[C[0]])+point(p)







︡ae40ae85-c1c3-4dad-a1ab-dbf5fcf2b8c9︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/187/tmp_ebWve_.svg","show":true,"text":null,"uuid":"f28cf01f-633a-457e-9f5f-a479f7424c6f"},"once":false}︡{"done":true}︡
︠0862fdfa-a964-4e15-ac72-854d1c1abdf0s︠
#Fuerza bruta búsqueda de aristas
# Hacemos un bucle con todas las combinaciones de aristas del poligono posibles. Luego cogemos otro punto y hallamos la orientación. Si es distinta de cero, comprobamos si ya teniamos esa orientación, 
def convexHullBF2(P):
    n=len(P)
    E=[]
    for i in Combinations(n,2):
        L=[]
        j=0
        while j < n:
            A = orientation(P[i[0]], P[i[1]], P[j])
            if A == 0:
                j += 1
                continue
            else:
                if A not in L:
                    L.append(A)
                if len(L) > 1:
                    L=[]
                    j += 1
                    break
            j += 1
        if len(L) == 1:
            E.append(i)
    C=[]
    for i in E:
        C.append(i[0])
        C.append(i[1])
    C = sorted(C)
    CC = [C[0]]
    for i in range(1, len(C)):
        if C[i] <> C[i-1]:
            CC.append(C[i])
    CH = starPolygonization([P[i] for i in CC])
    return CH
︡f5a6c5dd-45df-4ea8-8f2d-f4a96897fef1︡{"done":true}︡
︠f02aff3c-216e-4a5c-a083-d6324c8e4e04s︠
p=[[random(),random()] for i in range(10)]
C=convexHullBF2(p)
line(C+[C[0]]) + point(p)
︡47309a8f-7c09-455d-96e0-e41eddf89a0d︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/123/tmp_eFSP1s.svg","show":true,"text":null,"uuid":"3399acfb-7929-4313-b02d-db0dc4b150c5"},"once":false}︡{"done":true}︡
︠4ae46b21-5cfd-4cc9-b0e0-da9cc6329df4︠
︡6094ea7d-136c-462e-ae1f-24b20f40b263︡
︠76639ba8-966c-4aff-95c7-acf32b5ecb95︠
def jarvis(p):
    longitud=len(p)
    from operator import itemgetter
    referencia= min(p, key=itemgetter(1))
   
    resultado =[referencia]
    pactual=resultado[0]
    i=0
    while i<longitud:
        sa=[]
        for j in range(longitud):
            if(pactual!=p[i])and(pactual!=p[j])and(p[i]!=p[j]):
                sa.append(orientation(pactual,p[i],p[j]))
        if (0 not in sa)and(1 not in sa):
            if (p[i]!=referencia)and(p[i] not in resultado):
                resultado.append(p[i])
                pactual=p[i]
                i=0
            elif (p[i]==referencia):
                return resultado
                 
                 
            else:
                i=i+1
        if 1 in sa:
            i=i+1
    return resultado

︡650617e8-5901-4a90-b477-530c6ed723a0︡{"done":true}︡
︠d73324fb-63cc-4aaa-b14f-52579cc40d29︠

︡806a52d7-d57b-4a7f-9382-3c3ea40bfc29︡{"done":true}︡︡︡
︠e3343430-07e8-4bdf-ae47-7a12528f5e02︠

︡8545fb9f-4f8e-4cb9-ab74-3b241a11517a︡{"done":true}︡︡
︠894c7503-c064-430f-916a-0e941b70fd11s︠
p=[[random(),random()] for i in range(100)]
C=jarvis(p)
line(C+[C[0]],color="red") + point(p,color="green",size=30)
︡28a63fbf-fcdf-4683-8ced-8ef2084a08ab︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/122/tmp_nQfM7m.svg","show":true,"text":null,"uuid":"c983d78e-c49c-491f-ae37-d6d532155f0a"},"once":false}︡{"done":true}︡
︠cb87b80a-6c0f-4e3f-8107-6d5b7addbdf8s︠
#Algoritmo de Graham
#Este algoritmo utiliza una lista en la que va almacenando y ordenando correctamente los puntos que constituyen los extremos del cierre convexo.
#Primero elegimos un primer punto para almacenar en la lista. A continuación vamos almacenando el resto en la lista, ordenados según el valor del ángulo que forman con el primer punto que escogimos.
#Después recorremos la lista que hemos formado, tomando en cada momento tres puntos: Inicial, Medio y Final.
#Comprobamos la orientación que forman Inicial, Medio y Final (IMF).
#Si es positiva, Medio pasará a ser Inicial, Final pasará a ser Medio y el siguiente elemento de la lista pasará a ser Final.
#Si es negativa, Medio será borrado de la lista, Inicial pasará a ser Medio, el anterior elemento de la lista pasará a ser Inicial, y Final queda inalterado.
def convexHullGraham(p):
    P=deepcopy(p)
    from operator import itemgetter
    M = min(P, key=itemgetter(1))
    P = angularSort(P, M)
    i = 1 
    while P[i] <> M:
        if orientation(P[i-1], P[i], P[i+1])<0:
            del P[i]
            i -= 1
        else:
            i += 1
    return P
︡cd56a262-1639-4957-ae17-9cc2c87c7aa4︡{"done":true}︡
︠f923244e-8061-4496-a93a-9e83d9dabbd3s︠
p=[[random(),random()] for i in range(1000)]
C=convexHullGraham(p)
line(C+[C[0]]) + point(p)
︡d12bc803-fc8b-42f1-b1a2-a0302802525d︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/354/tmp_6Gyk2Q.svg","show":true,"text":null,"uuid":"d140f5ba-0b71-43db-bbfe-c12d305b8fcb"},"once":false}︡{"done":true}︡
︠44fbec4f-f4ba-4f83-bdde-b836b8528573s︠
#Quickhull 
#Tomamos los puntos más a la izquierda y el más a la derecha (ambos podemos
#confirmar que forman parte de la envolvente). Con recursividad y a partir de estos dos, cogiendo
#puntos de P por encima y por debajo encontramos el cierre convexo.

def dome(p,A,B):
    def comp(a):
        return sarea(B,A,a)
    if len(p)==0:
        return [B]
    M=max(p,key=comp)
    
    L1,L2=[],[]
    for i in p:
        if sarea(A,i,M)>0:
            L1.append(i)
        if sarea(M,i,B)>0:
            L2.append(i)
            
    return dome(L1, A, M) + dome(L2,M,B)+[B]
    
def quickhull(p):
    A,B=max(p), min(p)
    return dome(p,A,B)+dome(p,B,A)
︡6623e953-d144-45dc-b36a-4e015b4ea9e5︡{"done":true}︡
︠693ce0ef-97ca-4525-9014-9817831f5797s︠

p=[[random(),random()] for i in range(5000)]
C=quickhull(p)
line(C+[C[0]]) + point(p)
︡5e010081-9373-4610-8b6c-22c8defcbefe︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/354/tmp_FstyVr.svg","show":true,"text":null,"uuid":"714d2810-f357-466e-86ad-5a0d11f7a02c"},"once":false}︡{"done":true}︡
︠80a8daf1-1273-40a3-bdb8-2bc1939695a7s︠

from time import time
tiempos=[]

for i in range(1,100):
    p=[[random(),random()] for a in range(i*100)]
  
    t0=time()
    C=quickhull(p)
    t1=time()
    tiempos.append([a,t1-t0])

tiempos1=[]
for i in range(1,100):
    p=[[random(),random()] for a in range(i*100)]
  
    t0=time()
    C=convexHullGraham(p)
    t1=time()
    tiempos1.append([a,t1-t0])   


line(tiempos,legend_label='quickull',color="red")+line(tiempos1,legend_label='graham')

︡03694ca8-fc45-4d9d-b812-598539e5ab40︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/354/tmp_gG7Q0o.svg","show":true,"text":null,"uuid":"79f82cc4-aaa9-4bcd-8713-424f04b8d799"},"once":false}︡{"done":true}︡
︠daefa3de-cbf1-40fc-8f87-c7afef64d1e5i︠
%html
<p>&nbsp;</p>
<h1>Pr&aacute;ctica 4: ESTRUCTURA DCEL</h1>

︡c33149b8-1f11-440f-9752-7f8bb1d28446︡{"html": "<p>&nbsp;</p>\n<h1>Pr&aacute;ctica 4: ESTRUCTURA DCEL</h1>"}︡
︠f8db6bc1-9dc3-430e-b007-340ac2a89fc4︠
︡8fb24f9e-e351-4bc0-8caf-b4ba883403b8︡
︠cf8c5562-5ad2-4751-b820-256fd0ad89dci︠
%html
<p>&nbsp;</p>
<h2>Estructura de datos DCEL</h2>
<p><em style="font-weight: bold; font-style: normal; color: #6a6a6a; font-family: arial, sans-serif; font-size: small; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; background-color: #ffffff; text-decoration-style: initial; text-decoration-color: initial;">doubly connected edge list</em> (Lista de aristas doblemente enlazadas)</p>
<p>Es una estructura de datos que sirve para representar particiones planas.</p>
<p>En el caso que vamos a usar todas las caras son acotadas y simplemente conexas menos una cuyo borde tiene como borde una curva de Jordan.</p>
<p>Cada cara tiene como borde un pol&iacute;gono determinado por aristas. Todos los bordes estan orientados positivamente excepto el de la cara no acotada.</p>
<p>Cada arista forma parte del borde de una sola cara y posee una arista gemela que forma parte del borde de otra cara.</p>
<p>&nbsp;</p>
<p>Un DCEL D=[V, E, F] es una lista compuesta por tres listas: la de v&eacute;rtices, la de aristas y la de caras.</p>
<p>Los elementos de la lista de v&eacute;rtices V son pares [[x,y],k] formados por las coordenadas [x,y] de los v&eacute;rtices de la partici&oacute;n y el &iacute;ndice k de una de las aristas de las que el v&eacute;rtice es origen.</p>
<p>Los elementos de la lista de aristas E son qu&iacute;ntuplas de &iacute;ndices enteros [origen, gemela, anterior, posterior, cara]</p>
<p style="margin-left: 30px;">origen es el &iacute;ndice del v&eacute;rtice origen de la arista</p>
<p style="margin-left: 30px;">gemela es el &iacute;ndice de la arista gemela</p>
<p style="margin-left: 30px;">anterior y posterior son los &iacute;ndices de las aristas anterior y posterior a la arista en la cara a la que pertenece</p>
<p style="margin-left: 30px;">cara es el &iacute;ndice de la cara a la que pertenece la arista</p>
<p>La lista de caras contiene, por cada cara, el &iacute;ndice de una de las aristas de su borde.</p>
<p>Por conveniencia, la cara no acotada ser&aacute; siemmpre la cara 0.</p>

︡2d4a4f4b-f003-4705-9d4f-29e73be145c4︡{"html": "<p>&nbsp;</p>\n<h2>Estructura de datos DCEL</h2>\n<p><em style=\"font-weight: bold; font-style: normal; color: #6a6a6a; font-family: arial, sans-serif; font-size: small; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; background-color: #ffffff; text-decoration-style: initial; text-decoration-color: initial;\">doubly connected edge list</em> (Lista de aristas doblemente enlazadas)</p>\n<p>Es una estructura de datos que sirve para representar particiones planas.</p>\n<p>En el caso que vamos a usar todas las caras son acotadas y simplemente conexas menos una cuyo borde tiene como borde una curva de Jordan.</p>\n<p>Cada cara tiene como borde un pol&iacute;gono determinado por aristas. Todos los bordes estan orientados positivamente excepto el de la cara no acotada.</p>\n<p>Cada arista forma parte del borde de una sola cara y posee una arista gemela que forma parte del borde de otra cara.</p>\n<p>&nbsp;</p>\n<p>Un DCEL D=[V, E, F] es una lista compuesta por tres listas: la de v&eacute;rtices, la de aristas y la de caras.</p>\n<p>Los elementos de la lista de v&eacute;rtices V son pares [[x,y],k] formados por las coordenadas [x,y] de los v&eacute;rtices de la partici&oacute;n y el &iacute;ndice k de una de las aristas de las que el v&eacute;rtice es origen.</p>\n<p>Los elementos de la lista de aristas E son qu&iacute;ntuplas de &iacute;ndices enteros [origen, gemela, anterior, posterior, cara]</p>\n<p style=\"margin-left: 30px;\">origen es el &iacute;ndice del v&eacute;rtice origen de la arista</p>\n<p style=\"margin-left: 30px;\">gemela es el &iacute;ndice de la arista gemela</p>\n<p style=\"margin-left: 30px;\">anterior y posterior son los &iacute;ndices de las aristas anterior y posterior a la arista en la cara a la que pertenece</p>\n<p style=\"margin-left: 30px;\">cara es el &iacute;ndice de la cara a la que pertenece la arista</p>\n<p>La lista de caras contiene, por cada cara, el &iacute;ndice de una de las aristas de su borde.</p>\n<p>Por conveniencia, la cara no acotada ser&aacute; siemmpre la cara 0.</p>"}︡
︠a37360a9-8d30-4509-9924-5f8f29977074s︠
# funcion que crea un DCEL, para un poligono
def dcel(P):
    n=len(P)
    V=[[P[i],i] for i in range(len(P))]
    e=[[i,n+i,(i-1)%n,(i+1)%n,1]for i in range(n)]+[[(i+1)%n,i,n+(i+1)%n,n+(i-1)%n,0]for i in range(n)]
    f=[n,0]
    return [V,e,f]

# funciones para referirse a los elementos asociados a un elemento del DCEL

# indice del origen de una arista e
def origin(e,D):
    return D[1][e][0]

# coordenadas del origen de la arista e
def originCoords(e,D):
    return D[0][origin(e,D)][0]

# arista gemela de la arista e    
def twin(e,D):
    return D[1][e][1]

# arista previa de la arista e    
def prev(e,D):
    return D[1][e][2]

# arista siguiente de la arista e    
def next(e,D):
    return D[1][e][3] 

# indice de la cara de cuyo borde forma parte la arista e    
def face(e,D):
    return D[1][e][4]               

# indice de una de las aristas del borde de la cara c
def edge(c,D):
    return D[2][c]
        
# funcion para dibujar las aristas de un DCEL

def plotDCEL(D):
    return sum(line([originCoords(i,D),originCoords(twin(i,D),D)],aspect_ratio=1) for i in range(len(D[1])))  
    
# funcion para colorear una cara de un DCEL

def plotFace(c,D,col):

    f=D[2][c]
    C=[f]
    f=next(f,D)
    while f <> C[0]:
        C.append(f)
        f=next(f,D)
    
    P=[originCoords(j,D) for j in C]
    return polygon(P,color=col, alpha=.5)     

# funcion para colorear las caras de un DCEL
    
def colorDCEL(D):
    return sum(plotFace(i,D,(random(),random(),random())) for i in range(1,len(D[2])))
︡db6ec5af-7b1a-41b4-8af0-6fdb185a34a3︡{"done":true}︡
︠8f30df6e-9d7d-42fc-872a-53ac4391b9e0s︠
# funcion para dividir una cara del DCEL D por una diagonal
# e1 y e2 son las aristas cuyos orígenes son los extremos de la diagonal que divide la cara

def splitFace(e1,e2,D):
    
    # si no son aristas de la misma cara o si son adyacentes sus origenes no definen una diagonal
    if face(e1,D) <> face(e2,D) or origin(e2,D) == origin(twin(e1,D),D) or origin(e1,D) == origin(twin(e2,D),D):
        print "no diagonal"
        return
    
    nv, ne, nf = len(D[0]), len(D[1]), len(D[2])
    preve1 = prev(e1,D)
    preve2 = prev(e2,D)
    k=face(e1,D)
    
    # añadimos las aristas nuevas
    D[1].append([origin(e1,D),ne+1,preve1,e2,k])
    D[1].append([origin(e2,D),ne,preve2,e1,nf])
    
    # modificamos aristas afectadas
    D[1][preve1][3]=ne
    D[1][e1][2]=ne+1
    D[1][preve2][3]=ne+1
    D[1][e2][2]=ne
    i=e1
    while i<>ne+1:
        D[1][i][4]=nf
        i=next(i,D)
    
    #modificamos la cara afectada
    D[2][k]=ne
    
    # añadimos la nueva cara
    D[2].append(ne+1)
︡bf6cdb0f-97d6-44d4-a07a-d37b8318f087︡{"done":true}︡
︠70f91a3a-b389-496d-ab98-cecf5545ba38s︠
# prueba
p=[[random(),random()] for i in range(50)]
P=polygonization(p)
D=dcel(P)
splitFace(0,len(p)-2,D)
plotDCEL(D)+colorDCEL(D)
︡78af18ab-a22d-42f0-813b-78a6a837f30a︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/188/tmp_poYIZr.svg","show":true,"text":null,"uuid":"fed6b8f8-69b6-4029-a5f0-a7bbf78d522d"},"once":false}︡{"done":true}︡
︠2bac2a4f-dc6c-4ceb-86ce-9ae4feca1757i︠
%html
<h2>Ejercicios:</h2>
<ol>
<li>Genera un ejemplo con la prueba anterior y rev&iacute;salo para comprobar si se trata de una partici&oacute;n correcta delpol&iacute;gono y si el DCEL es correcto.</li>
<li>Emplea la funci&oacute;n <strong>splitFace</strong> para terminar de triangular el pol&iacute;gono del ejemplo anterior.</li>
<li>Define una funci&oacute;n <strong>faceEdges(c,D)</strong> que obtenga la lista de los indices de las aristas del borde de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</li>
<li>Define una funci&oacute;n <strong>faceVertices(c,D)</strong> que obtenga la lista de los indices de los vertices del borde de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</li>
<li>Define una funci&oacute;n <strong>faceVerticesCoords(c,D)</strong> que obtenga el poligono borde de la cara c del DCEL D (con la orientaci&oacute;n de c)</li>
<li>Define una funci&oacute;n <strong>faceNeighbors(c,D)</strong> que obtenga la lista de los indices de las caras vecinas de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</li>
<li>Define una funci&oacute;n <strong>vertexEdges(v,D)</strong> que obtenga la lista de los indices de las aristas del DCEL D cuyo origen es v (en orden angular positivo)</li>
<li>Define una funci&oacute;n <strong>vertexFan(v,D)</strong> que obtenga la lista de los indices de las caras del DCEL D que contienen al v&eacute;rtice v en su borde (en orden angular positivo)</li>
<li>Define una funci&oacute;n <strong>convexHullDCEL(D)</strong> que triangule el exterior del borde de la cara externa iterando la funci&oacute;n <strong>splitFace</strong></li>
<li>Define una funci&oacute;n <strong>triangulation(p)</strong> que obtenga el DCEL de una triangulaci&oacute;n de la lista de puntos p.</li>
</ol>

︡58260ece-5830-43fa-9508-d73bf49a695d︡{"done":true,"html":"<h2>Ejercicios:</h2>\n<ol>\n<li>Genera un ejemplo con la prueba anterior y rev&iacute;salo para comprobar si se trata de una partici&oacute;n correcta delpol&iacute;gono y si el DCEL es correcto.</li>\n<li>Emplea la funci&oacute;n <strong>splitFace</strong> para terminar de triangular el pol&iacute;gono del ejemplo anterior.</li>\n<li>Define una funci&oacute;n <strong>faceEdges(c,D)</strong> que obtenga la lista de los indices de las aristas del borde de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</li>\n<li>Define una funci&oacute;n <strong>faceVertices(c,D)</strong> que obtenga la lista de los indices de los vertices del borde de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</li>\n<li>Define una funci&oacute;n <strong>faceVerticesCoords(c,D)</strong> que obtenga el poligono borde de la cara c del DCEL D (con la orientaci&oacute;n de c)</li>\n<li>Define una funci&oacute;n <strong>faceNeighbors(c,D)</strong> que obtenga la lista de los indices de las caras vecinas de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</li>\n<li>Define una funci&oacute;n <strong>vertexEdges(v,D)</strong> que obtenga la lista de los indices de las aristas del DCEL D cuyo origen es v (en orden angular positivo)</li>\n<li>Define una funci&oacute;n <strong>vertexFan(v,D)</strong> que obtenga la lista de los indices de las caras del DCEL D que contienen al v&eacute;rtice v en su borde (en orden angular positivo)</li>\n<li>Define una funci&oacute;n <strong>convexHullDCEL(D)</strong> que triangule el exterior del borde de la cara externa iterando la funci&oacute;n <strong>splitFace</strong></li>\n<li>Define una funci&oacute;n <strong>triangulation(p)</strong> que obtenga el DCEL de una triangulaci&oacute;n de la lista de puntos p.</li>\n</ol>"}
︠d8c263f0-082f-470c-8096-8c3b4599b652s︠
# prueba
p=[[random(),random()] for i in range(20)]
P=polygonization(p)
D=dcel(P)
splitFace(0,len(p)-2,D)
V= [D[0][j][0] for j in range (len(D[0]))]
plotDCEL(D)+colorDCEL(D)+point(V,color="red",size=30)
︡285654ad-bbe0-40f9-859f-d4dc410e24b7︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/188/tmp_mWfJfh.svg","show":true,"text":null,"uuid":"50c18f74-f7a9-40b9-a2e7-3d5e3451954c"},"once":false}︡{"done":true}︡
︠9e42316f-9b88-4708-a110-9f999df98b7fs︠

︡2ebf8a01-15f7-4022-a00b-e59f72498a26︡{"done":true}︡
︠d42fbdd7-c136-450f-8123-ee311e4ae838s︠
V= [D[0][j][0] for j in range (len(D[0]))]
plotDCEL(D)+colorDCEL(D)+point(V,color="red",size=30)
︡b47ef274-d160-4ff3-b94d-b06994573355︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/188/tmp_QKeFRq.svg","show":true,"text":null,"uuid":"98894419-ad4f-41d2-9ab6-83c10eda9308"},"once":false}︡{"done":true}︡
︠44ae940e-3db8-484a-9b59-6cbf324dedb1i︠
%html
<p>Define una funci&oacute;n <strong>faceEdges(c,D)</strong> que obtenga la lista de los indices de las aristas del borde de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</p>

︡2532821b-4bd4-4204-a6d9-061891b07a8f︡{"done":true,"html":"<p>Define una funci&oacute;n <strong>faceEdges(c,D)</strong> que obtenga la lista de los indices de las aristas del borde de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</p>"}
︠a3f8a8a7-8614-46b0-8d3b-c48d664dba2as︠
def faceEdges(c,D):
    e=edge(c,D)
    C=[e]
    e=next(e,D)
    while e <> C[0]:
        C.append(e)
        e=next(e,D)
    return C
︡fadf5ade-d7ef-429d-bfa3-b5f4544d2742︡{"done":true}︡
︠98e1a30a-87ef-45db-8412-7f71cd2cde78i︠
%html
<p><span id="cell_outer_3">Define una funci&oacute;n <strong>faceVertices(c,D)</strong> que obtenga la lista de los indices de los vertices del borde de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</span></p>

︡5704be4e-04d0-4c93-b9d3-9d06004a5ff0︡{"done":true,"html":"<p><span id=\"cell_outer_3\">Define una funci&oacute;n <strong>faceVertices(c,D)</strong> que obtenga la lista de los indices de los vertices del borde de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</span></p>"}
︠d599e978-e352-4626-9002-35a8ca95a1c9s︠
def faceVertices(c,D):
    A = faceEdges(c,D)
    V = [D[1][A[i]][0] for i in range(len(A))]
    return V
︡38cc8a91-91bf-4298-9971-fa4be87dfb95︡{"done":true}︡
︠b7122dcd-9bdb-4559-afc1-a373d1dfabedi︠
%html
<p><span id="cell_outer_3">Define una funci&oacute;n <strong>faceVerticesCoords(c,D)</strong> que obtenga el poligono borde de la cara c del DCEL D (con la orientaci&oacute;n de c)</span></p>

︡2471607f-c7b1-4733-b105-2a3ed0e9b092︡{"done":true,"html":"<p><span id=\"cell_outer_3\">Define una funci&oacute;n <strong>faceVerticesCoords(c,D)</strong> que obtenga el poligono borde de la cara c del DCEL D (con la orientaci&oacute;n de c)</span></p>"}
︠f4d0415a-e776-4640-84c0-0f32401391ffs︠
def faceVerticesCoords(c,D):
    A = faceEdges(c,D)
    coords = [originCoords(A[i],D) for i in range(len(A))]
    return A
︡709fb866-a3e3-48f9-8b1a-d377c1b856c9︡{"done":true}︡
︠a9a1aa79-9231-4e49-a397-81ca0260886es︠

︡dcc43d25-4ec3-4528-98dd-434e2f00fc2d︡{"done":true}︡
︠836c7e9e-25bc-45e3-aa4b-39af4b0b8357i︠
%html
<p><span id="cell_outer_3">Define una funci&oacute;n <strong>faceNeighbours(c,D)</strong> que obtenga la lista de los indices de las caras vecinas de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</span></p>

︡339e8264-7432-45e2-b668-baed7e404620︡{"done":true,"html":"<p><span id=\"cell_outer_3\">Define una funci&oacute;n <strong>faceNeighbours(c,D)</strong> que obtenga la lista de los indices de las caras vecinas de la cara c del DCEL D (en el orden en que aparecen al recorrer el borde de c)</span></p>"}
︠adc31533-a546-4865-92bd-c22329b48a24s︠
def faceNeighbours(c,D):
    A = faceEdges(c,D)
    coords = [twin(A[i],D) for i in range(len(A))]
    return A
︡d991fc53-6632-4286-9129-8217ca4cc9a9︡{"done":true}︡
︠f137454f-be96-40fe-b9be-dbc13cb6aa58i︠
%html
<p><span id="cell_outer_3">Define una funci&oacute;n <strong>vertexEdges(v,D)</strong> que obtenga la lista de los indices de las aristas del DCEL D cuyo origen es v (en orden angular positivo)</span></p>

︡7aace165-bf8d-4143-892a-f12326732f33︡{"done":true,"html":"<p><span id=\"cell_outer_3\">Define una funci&oacute;n <strong>vertexEdges(v,D)</strong> que obtenga la lista de los indices de las aristas del DCEL D cuyo origen es v (en orden angular positivo)</span></p>"}
︠29ae934f-0122-4d6c-a623-c89f09d708a7s︠
def vertexEdges(v,D):
    e0=D[0][v][1]
    E=[e0]
    e=twin(prev(e0,D),D)
    while e<>e0:
        E.append(e)
        e=twin(prev(e,D),D)
    return E
︡88d32190-c192-4ff6-bd01-07eef5c152d7︡{"done":true}︡
︠9d215570-84f8-47c6-a2e9-944f30690d2di︠
%html
<p><span id="cell_outer_3">Define una funci&oacute;n <strong>vertexFan(v,D)</strong> que obtenga la lista de los indices de las caras del DCEL D que contienen al v&eacute;rtice v en su borde (en orden angular positivo)</span></p>

︡77002f40-a153-4a46-a651-118fbc0d0397︡{"done":true,"html":"<p><span id=\"cell_outer_3\">Define una funci&oacute;n <strong>vertexFan(v,D)</strong> que obtenga la lista de los indices de las caras del DCEL D que contienen al v&eacute;rtice v en su borde (en orden angular positivo)</span></p>"}
︠3b1ac10d-ad5c-454c-baab-6eeb60d5bef2s︠
def vertexFan(v,D):
    A=vertexEdges(v,D)
    C=[face(A[i],D) for i in range(len(A))]
    return C

︡683caae7-a0e7-49eb-9ef3-0065f81871c9︡{"done":true}︡
︠2113ee6f-6fb8-4c50-bcb4-893fbe3746bes︠
# CONVEX HULL
# esta funcion no sirve en general
# pero si para casos en que la cara externa es un poligono estrellado o monotono
def DCELconvexHull(D): #scan de Graham
    E=faceEdges(0,D)
    V=[[originCoords(i,D),i] for i in E]
    m=min(V)[1]
    e=next(m,D)
    while origin(e,D)<>origin(m,D):
        if sarea(originCoords(prev(e,D),D),originCoords(e,D),originCoords(next(e,D),D))>0:
            e1=prev(e,D)
            e2=next(e,D)
            splitFace(e1,e2,D)
            if origin(prev(e2,D),D)<>origin(m,D):
                e=prev(e2,D)
            else:
                e=e2
        else:
            e=next(e,D)
︡f1e59390-5d72-470e-996e-091935c3f792︡{"done":true}︡
︠10b05223-deff-4ad2-9dab-f2a0f11770b4s︠
def triangulation(p):
    n=len(p)
    P=[[i[1],i]for i in p]
    M=min(P)[0]  #punto de menor ordenada
    P=angularSort(p,M)
    D=dcel(P)
    for i in range(3,n):  #triangulacion de la cara acotada
        splitFace(n-i,n-1,D)
    DCELconvexHull(D)  #scan de Graham
    return D         

   
def triangulation(p):
    n=len(p)
    P=[[i[1],i]for i in p]
    M=min(P)[1]  #punto de menor ordenada
    P=angularSort(p,M)
    D=dcel(P)
    DCELconvexHull(D)  #scan de Graham
    for i in range(3,n):  #triangulacion de la cara acotada
        splitFace(n-i,n-1,D)
    
    return D
︡1b898eb7-97cc-44ab-a58a-e7358c34ef4f︡{"done":true}︡
︠2969285c-4cfd-4b09-9f5f-9fec20391eabs︠

︡b8e80ece-4484-4a63-8680-1e5888701399︡{"done":true}︡
︠ab828330-c592-480e-abd6-831643758ccdi︠
%html
<p>&nbsp;</p>
<h2>Triangulaci&oacute;n de Delaunay</h2>

<h2>Ejercicios:</h2>
<ol>
<li>Define una funci&oacute;n <strong>flipable(a,D)</strong> que analice si laarista a del DCEL D es flipable</li>
<li>Define una funci&oacute;n <strong>legal(a,D)</strong> que analice si la arista a del DCEL D es legal</li>
<li>Define una funci&oacute;n <strong>legalize(T)</strong> que legalice las aristas de la triangulaci&oacute;n T mediante flips</li>
<li>Define la funci&oacute;n <strong>delone(p)</strong> que calcule la triangulaci&oacute;n de Delaunay de una lista de puntos p</li>
</ol>
<p>Puedes emplear la siguiente funci&oacute;n para flipar una arista flipable:</p>
<p><br />def flip(a,D):<br />&nbsp;&nbsp;&nbsp; ga=D[1][a][1]<br />&nbsp;&nbsp;&nbsp; ca=D[1][a][4]<br />&nbsp;&nbsp;&nbsp; aa=D[1][a][2]<br />&nbsp;&nbsp;&nbsp; pa=D[1][a][3]<br />&nbsp;&nbsp;&nbsp; cb=D[1][ga][4]<br />&nbsp;&nbsp;&nbsp; ab=D[1][ga][2]<br />&nbsp;&nbsp;&nbsp; pb=D[1][ga][3]<br />&nbsp;&nbsp;&nbsp; D[1][a]=[D[1][aa][0],ga,pa,ab,ca]<br />&nbsp;&nbsp;&nbsp; D[1][ga]=[D[1][ab][0],a,pb,aa,cb]<br />&nbsp;&nbsp;&nbsp; D[1][pa][2]=ab<br />&nbsp;&nbsp;&nbsp; D[1][pa][3]=a<br />&nbsp;&nbsp;&nbsp; D[1][aa][2]=ga<br />&nbsp;&nbsp;&nbsp; D[1][aa][3]=pb<br />&nbsp;&nbsp;&nbsp; D[1][aa][4]=cb<br />&nbsp;&nbsp;&nbsp; D[1][pb][2]=aa<br />&nbsp;&nbsp;&nbsp; D[1][pb][3]=ga<br />&nbsp;&nbsp;&nbsp; D[1][ab][2]=a<br />&nbsp;&nbsp;&nbsp; D[1][ab][3]=pa<br />&nbsp;&nbsp;&nbsp; D[1][ab][4]=ca<br />&nbsp;&nbsp;&nbsp; return</p>

︡d5118ce7-3a1d-4f32-9053-572a65b450ce︡{"done":true,"html":"<p>&nbsp;</p>\n<h2>Triangulaci&oacute;n de Delaunay</h2>\n\n<h2>Ejercicios:</h2>\n<ol>\n<li>Define una funci&oacute;n <strong>flipable(a,D)</strong> que analice si laarista a del DCEL D es flipable</li>\n<li>Define una funci&oacute;n <strong>legal(a,D)</strong> que analice si la arista a del DCEL D es legal</li>\n<li>Define una funci&oacute;n <strong>legalize(T)</strong> que legalice las aristas de la triangulaci&oacute;n T mediante flips</li>\n<li>Define la funci&oacute;n <strong>delone(p)</strong> que calcule la triangulaci&oacute;n de Delaunay de una lista de puntos p</li>\n</ol>\n<p>Puedes emplear la siguiente funci&oacute;n para flipar una arista flipable:</p>\n<p><br />def flip(a,D):<br />&nbsp;&nbsp;&nbsp; ga=D[1][a][1]<br />&nbsp;&nbsp;&nbsp; ca=D[1][a][4]<br />&nbsp;&nbsp;&nbsp; aa=D[1][a][2]<br />&nbsp;&nbsp;&nbsp; pa=D[1][a][3]<br />&nbsp;&nbsp;&nbsp; cb=D[1][ga][4]<br />&nbsp;&nbsp;&nbsp; ab=D[1][ga][2]<br />&nbsp;&nbsp;&nbsp; pb=D[1][ga][3]<br />&nbsp;&nbsp;&nbsp; D[1][a]=[D[1][aa][0],ga,pa,ab,ca]<br />&nbsp;&nbsp;&nbsp; D[1][ga]=[D[1][ab][0],a,pb,aa,cb]<br />&nbsp;&nbsp;&nbsp; D[1][pa][2]=ab<br />&nbsp;&nbsp;&nbsp; D[1][pa][3]=a<br />&nbsp;&nbsp;&nbsp; D[1][aa][2]=ga<br />&nbsp;&nbsp;&nbsp; D[1][aa][3]=pb<br />&nbsp;&nbsp;&nbsp; D[1][aa][4]=cb<br />&nbsp;&nbsp;&nbsp; D[1][pb][2]=aa<br />&nbsp;&nbsp;&nbsp; D[1][pb][3]=ga<br />&nbsp;&nbsp;&nbsp; D[1][ab][2]=a<br />&nbsp;&nbsp;&nbsp; D[1][ab][3]=pa<br />&nbsp;&nbsp;&nbsp; D[1][ab][4]=ca<br />&nbsp;&nbsp;&nbsp; return</p>"}
︠05f09adb-8eaa-4d3c-b8b3-c8627d77494ds︠
def flip(a,D):
    oa=D[1][a][0]
    ga=D[1][a][1]
    ca=D[1][a][4]
    aa=D[1][a][2]
    pa=D[1][a][3]
    cb=D[1][ga][4]
    ab=D[1][ga][2]
    pb=D[1][ga][3]
    oga=D[1][ga][0]
    D[1][a]=[D[1][aa][0],ga,pa,ab,ca]
    D[1][ga]=[D[1][ab][0],a,pb,aa,cb]
    D[1][pa][2]=ab
    D[1][pa][3]=a
    D[1][aa][2]=ga
    D[1][aa][3]=pb
    D[1][aa][4]=cb
    D[1][pb][2]=aa
    D[1][pb][3]=ga
    D[1][ab][2]=a
    D[1][ab][3]=pa
    D[1][ab][4]=ca
    D[2][ca]=a
    D[2][cb]=ga
    D[0][oa][1]=pb
    D[0][oga][1]=pa

    return 
︡4afb5d1a-9976-4bfd-b58a-614a7c7ac91b︡{"done":true}︡
︠5a46c794-5c6e-446f-adb6-de97557396b2s︠
#flipable(a,D)
def flipable(a,D):
    if face(a,D)==0 or face(twin(a,D),D)==0:
        return false
    A,B,C,D = originCoords(a,D),originCoords(prev(twin(a,D),D),D),originCoords(twin(a,D),D),originCoords(prev(a,D),D)
    if sarea(A,B,C)>0 and sarea(B,C,D)>0 and sarea(C,D,A)>0 and sarea(D,A,B)>0:
        return True
    return false
︡3482112e-f72c-4981-a24b-95682e445aaf︡{"done":true}︡
︠0cc0700d-1017-48a3-a220-d971edeecbffs︠
################################
# contador de aristas illegal
################################
def illegal(D):
    j=0
    for i in range(len(D[1])):
        if legal(i,D)==-1:
            j=j+1
    return j/2
︡976d414d-dbd3-4adc-8346-424793313499︡{"done":true}︡
︠7c35179f-fff1-411f-8041-dc560f56407ds︠
################################
# contador de aristas flipables
################################
def flipables(D):
    j=0
    for i in range(len(D[1])):
        if flipable(i,D)==1:
            j=j+1
    return j/2
︡b8c29c95-65a2-4ed5-bf4a-8fb58ede3d76︡{"done":true}︡
︠80c1355d-6668-40c3-b5cc-a81af02f9262s︠
#legal(a,D)
def legal(a,D):
    if flipable(a,D)==-1:
        return true
    A,B,C,D = originCoords(a,D),originCoords(prev(twin(a,D),D),D),originCoords(twin(a,D),D),originCoords(prev(a,D),D)
    if inCircle(A,C,D,B)==false:
        return True
    else:
        return False
︡822b662b-d18c-4d25-a6a3-13f7119bfab4︡{"done":true}︡
︠7d4498de-7883-4446-b8ec-ebdc7bdd9664s︠

︡1759a07c-9aff-4744-bede-26e532acd7af︡{"done":true}︡
︠ca7db523-fd7a-481b-9227-3cf9fdfbe6b5s︠
#legalize(T)
def legalize(t):
    T=deepcopy(t)
    c=1
    vueltas=0
    flips=0
    while c>0:
        vueltas=vueltas+1
        c=0
        for i in range(len(T[1])):
            if legal(i,T)==-1:
                flip(i,T)
                flips=flips+1
                c=c+1
    print "num vueltas: ",vueltas,"num flips: ",flips
    return T

︡a27b73bb-0029-48dc-8b08-37919de0ecf9︡{"done":true}︡
︠5d275253-bbaf-44b0-966a-26f04310e867s︠
def delone(p):
    k=triangulation(p)
    k=legalize(k)
    return k
︡1bf3c316-7653-4784-9ab1-15c10e19443f︡{"done":true}︡
︠962ae7b3-6af3-4596-bc29-871cf19234e8s︠
# Prueba

p=[[random(),random()]for i in range(20)]
T=triangulation(p)

DT=delone(p)

plotDCEL(DT)+colorDCEL(DT)
︡41e4a615-4ba3-4777-8db5-f9b1a6d8ad92︡{"stdout":"num vueltas:  1 num flips:  0\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-6f1e1341-b9df-4c33-acef-0287e8357f90/188/tmp_deLFzr.svg","show":true,"text":null,"uuid":"9f498b8a-77cd-4d53-aba5-e1702c10b27e"},"once":false}︡{"done":true}︡
︠29262423-658d-435e-9aa2-32674f8ae5acs︠




︡9c75cf17-cfdb-401f-a2af-d113b46c9fcd︡{"done":true}︡
︠bd676cc4-db32-4fe5-94e7-94db6a5f9432s︠

︡22370a76-1052-42e5-ab96-f5928bccf2cf︡{"done":true}︡
︠c1fb0848-0bfc-49c1-95fb-0a3d7f629ddbi︠
%html
<p>&nbsp;</p>
<h2>Diagrama de Voronoi</h2>
<p>El diagrama de Voronoi de n puntos del plano es la descomposici&oacute;n del plano en n regiones cada una de las cuales es el lugar geom&eacute;trico de los puntos del plano m&aacute;s pr&oacute;ximos a uno de los puntos dados que al resto.</p>
<p>Cada una de esas regiones se llama regi&oacute;n de Voronoi del punto correspondiente.</p>
<p>Demuestra las siguientes propiedades:</p>
<ol>
<li>El diagrama de Voronoi de n puntos tiene n regiones no vac&iacute;as.</li>
<li>Las regiones de Voronoi son regiones poligonales convexas.</li>
<li>La regi&oacute;n de Voronoi de un punto que sea v&eacute;rtice de la envolvente convexa es no acotada.</li>
<li>La regi&oacute;n de Voronoi de un punto que no sea v&eacute;rtice de la envolvente convexa es acotada.</li>
<li>La intersecci&oacute;n de las fronteras de dos regiones de Voronoi es:<ol>
<li>Vac&iacute;a</li>
<li>o un punto</li>
<li>o un segmento</li>
<li>o una semirrecta</li>
<li>o una recta (en el caso de solo dos puntos o de m&aacute;s de dos todos&nbsp; alineados)</li>
</ol></li>
<li>La frontera com&uacute;n de las regiones de Voronoi de dos puntos $p_i$ y $p_j$ est&aacute; contenida en la mediatriz de $p_i$ y $p_j$.</li>
<li>Los v&eacute;rtices del diagrama de Voronoi equidistan de tres o m&aacute;s puntos generadores del diagrama.</li>
<li>El grafo dual del diagrama de Voronoi de n puntos es el que tiene como v&eacute;rtices los n puntos y dos de ellos est&aacute;n conectados por una arista rectil&iacute;nea si, y solo si, las regiones de los dos puntos comparten frontera con m&aacute;s de un punto. Si los puntos est&aacute;n en posici&oacute;n general (no degenerada), se verifica que el grafo dual del diagrama de Voronoi es la triangulaci&oacute;n de Delaunay.</li>
</ol>
<p>Vamos a obtener el diagrama de Voronoi a partir de la triangulaci&oacute;n de Delaunay.</p>
<h2>Ejercicios:</h2>
<ol>
<li>Define una funci&oacute;n <strong>voronoiRegion(v,D,R)</strong> que calcule la regi&oacute;n de Voronoi del v&eacute;rtice v, recortada por el rect&aacute;ngulo R, de la triangulaci&oacute;n de Delaunay D (definida por un DCEL)</li>
<li>Define una funci&oacute;n <strong>Voronoi(p,R) </strong>que calcule el diagrama de Voronoi de un conjunto de puntos p recortado por el rect&aacute;ngulo R.<strong><br /></strong></li>
</ol>

︡6ce08bea-2ea8-4dcc-abed-abf2b1531435︡{"done":true,"html":"<p>&nbsp;</p>\n<h2>Diagrama de Voronoi</h2>\n<p>El diagrama de Voronoi de n puntos del plano es la descomposici&oacute;n del plano en n regiones cada una de las cuales es el lugar geom&eacute;trico de los puntos del plano m&aacute;s pr&oacute;ximos a uno de los puntos dados que al resto.</p>\n<p>Cada una de esas regiones se llama regi&oacute;n de Voronoi del punto correspondiente.</p>\n<p>Demuestra las siguientes propiedades:</p>\n<ol>\n<li>El diagrama de Voronoi de n puntos tiene n regiones no vac&iacute;as.</li>\n<li>Las regiones de Voronoi son regiones poligonales convexas.</li>\n<li>La regi&oacute;n de Voronoi de un punto que sea v&eacute;rtice de la envolvente convexa es no acotada.</li>\n<li>La regi&oacute;n de Voronoi de un punto que no sea v&eacute;rtice de la envolvente convexa es acotada.</li>\n<li>La intersecci&oacute;n de las fronteras de dos regiones de Voronoi es:<ol>\n<li>Vac&iacute;a</li>\n<li>o un punto</li>\n<li>o un segmento</li>\n<li>o una semirrecta</li>\n<li>o una recta (en el caso de solo dos puntos o de m&aacute;s de dos todos&nbsp; alineados)</li>\n</ol></li>\n<li>La frontera com&uacute;n de las regiones de Voronoi de dos puntos $p_i$ y $p_j$ est&aacute; contenida en la mediatriz de $p_i$ y $p_j$.</li>\n<li>Los v&eacute;rtices del diagrama de Voronoi equidistan de tres o m&aacute;s puntos generadores del diagrama.</li>\n<li>El grafo dual del diagrama de Voronoi de n puntos es el que tiene como v&eacute;rtices los n puntos y dos de ellos est&aacute;n conectados por una arista rectil&iacute;nea si, y solo si, las regiones de los dos puntos comparten frontera con m&aacute;s de un punto. Si los puntos est&aacute;n en posici&oacute;n general (no degenerada), se verifica que el grafo dual del diagrama de Voronoi es la triangulaci&oacute;n de Delaunay.</li>\n</ol>\n<p>Vamos a obtener el diagrama de Voronoi a partir de la triangulaci&oacute;n de Delaunay.</p>\n<h2>Ejercicios:</h2>\n<ol>\n<li>Define una funci&oacute;n <strong>voronoiRegion(v,D,R)</strong> que calcule la regi&oacute;n de Voronoi del v&eacute;rtice v, recortada por el rect&aacute;ngulo R, de la triangulaci&oacute;n de Delaunay D (definida por un DCEL)</li>\n<li>Define una funci&oacute;n <strong>Voronoi(p,R) </strong>que calcule el diagrama de Voronoi de un conjunto de puntos p recortado por el rect&aacute;ngulo R.<strong><br /></strong></li>\n</ol>"}
︠f86ec978-3c12-4860-b728-13d368fd8da8s︠
def infiniteVertex(e,D):
    A = originCoords(e,D)
    B = originCoords(next(e,D),D)
    v = vector(B)-vector(A)
    v0 = vector([-v[1],v[0]])
    v0 *= 100/v0.norm()
    M = midPoint(A,B)
    C = vector(M)+v0
    return list(C)
︡784f90ba-2df9-4688-9d30-805b480500e5︡{"done":true}︡
︠d58d1f11-725d-4e46-852f-abdc2c622991︠

︡baea283f-a82b-497a-afc8-fb63938af0a5︡
︠f390785d-d3b8-47b6-8d9d-289c66dfa936s︠
def voronoiRegion(i, D):
    F = vertexFan(i,D)
    R = []
    for i in len(F):
        if face(i,D) != 0:
            A,B,C = originCoords(prev(i,D),D),originCoords(i,D),originCoords(next(i,D),D)
            R.append(circumcenter(A,B,C))
        else:
            R.append(infiniteVertex(i,D))
            R.append(infiniteVertex(prev(i,D),D))
    return R
︡e8414ff4-ef03-4422-962c-f12fee49aa70︡{"done":true}︡
︠46198c28-4f24-4509-855e-6eae54e586d3s︠

def voronoi(D): #2n
    V=[]
    for i in range(len(D[0])):
        r = voronoiRegion(i,D)
        V.append(r)
    return V
︡699d5d3b-0b44-4297-ba2d-61875f7b1a43︡{"done":true}︡
︠7821b84a-64dc-412d-8c0b-65e5c4c1ae04s︠
p=[[random(),random()]for i in range(10)]
DT=delone(p)
V = voronoi(DT)

print(V)


︡eac6dd4c-789f-4c21-916a-f104b09e8e68︡{"stdout":"num vueltas:  1 num flips:  0\n"}︡{"stderr":"Error in lines 3-3\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1013, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"\", line 4, in voronoi\n  File \"\", line 4, in voronoiRegion\nTypeError: 'int' object is not iterable\n"}︡{"done":true}︡
︠365e1ea1-4183-405b-9506-b639f86cf047s︠

︡2ffa486e-ab1e-410c-917d-1cc21a6d2465︡{"done":true}︡
︠ababf556-ebf9-4d1d-b1d1-561bf9b322c4︠
def dentroCirculoGeneradoPorP(p,r,a):
    if(dist(a,p)<=r): return 1
    else: return 0
︡a3f77e63-256c-45d5-ab0a-de54ea28e31f︡
︠69af2855-c2a7-46e3-8240-d1b09a8bcc33︠
def voronoiRegion(i, D):
    punto=D[0][i][0]
    listavertices=[]
    for c in len(D[0]):
        listavertices.append(D[a][0])
    listapuntos=[]
    while(len(listapuntos))<3:
        for a in Combinations(listavertices,3):
            if(circumcenter(a[0],a[1],a[2]))==punto:
                listapuntos.append(a[0])
                listapuntos.append(a[0])
                listapuntos.append(a[0])
                radio=dist(punto,a[0])
                for c in range(len(listavertices)):
                    if(listavertices[c]!=a[0])and(listavertices[c]!=a[0])and(listavertices[c]!=a[0])and(dentroCirculoGeneradoPorP(punto,radio,listavertices[c])==1):listapuntos.append(listavertices[c])
                        
        
    for a in range(len(lista)):
        
    F = vertexEdges(i,D)
    R = []
    for i in F:
        if face(i,D) != 0:
            A,B,C = originCoords(prev(i,D),D),originCoords(i,D),originCoords(next(i,D),D)
            R.append(circumcenter(A,B,C))
        else:
            R.append(infiniteVertex(i,D))
            R.append(infiniteVertex(prev(i,D),D))
    return R
︡b7339aa5-0143-4365-945a-92c52bc52cc0︡
︠a729734a-c44e-481e-b3e1-0e0c3b9b4f67s︠

︡21ce6584-c706-492b-aa7e-ebdc872aff94︡{"done":true}︡











